//---------------------------------------------------------------------------
//
//	Ao[h
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "prime4.h"
#include "album.h"
#include "graph.h"
#include "event_grp.h"
#include "sound_data.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define ALBUM_LIST_EV				106
#define ALBUM_LIST_VA				32
#define ALBUM_LIST_ED				43

#define ALBUM_MODE_INIT				0
#define ALBUM_MODE_WAIT				1
#define ALBUM_MODE_MAIN				2
#define ALBUM_MODE_DECIDE			3
#define ALBUM_MODE_TRANS			4

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static u8
	g_step,
	g_count,
	g_tag,
	g_decide;
static s16
	g_wait,
	g_ev_page,
	g_va_page,
	g_ed_page;
static u16
	g_bg_list[9];
static void
	*g_bg_buf;

static u16
	g_ev_list[ALBUM_LIST_EV] = 
	{
		// Cxg摜
		BG_ev01,
		BG_ev02,
		BG_ev03,
		BG_ev04,
		BG_ev05,
		BG_ev06,
		BG_ev07,
		BG_ev08,
		BG_ev09,
		BG_ev10,
		BG_ev11,
		BG_ev12,
		BG_ev13,
		BG_ev14,
		BG_ev15,
		BG_ev16,
		BG_ev17,
		BG_ev18,
		BG_ev19,
		BG_ev20,
		BG_ev21a,
		BG_ev21b,
		BG_ev21c,
		BG_ev21d,
		BG_ev21e,
		BG_ev21f,
		BG_ev22,
		BG_ev23,
		BG_ev24,
		BG_ev25,
		BG_ev26,
		BG_ev27,
		BG_ev28,
		BG_ev29,
		BG_ev30,
		BG_ev31,
		BG_ev32,
		BG_ev33,
		BG_ev34a,
		BG_ev34b,
		BG_ev34c,
		BG_ev34d,
		BG_ev35,
		BG_ev36,
		BG_ev37,
		BG_ev38,
		BG_ev39,
		BG_ev40,
		BG_ev41,
		BG_ev42,
		BG_ev43,
		BG_ev44a,
		BG_ev44b,
		BG_ev44c,
		BG_ev45,
		BG_ev46,
		BG_ev47,
		BG_ev48,
		BG_ev49,
		BG_ev50,
		BG_ev51,
		BG_ev52,
		BG_ev53,
		BG_omk01,
		BG_omk02,
		BG_omk03,
		BG_omk04,
		BG_omk05,
		BG_omk06,
		BG_omk07,
		BG_omk08,
		BG_omk09,
		BG_omk10,
		BG_omk11,
		BG_omk12,
		BG_omk13,
		BG_omk14,
		BG_omk15,
		BG_omk16,
		BG_omk17,
		BG_omk18,
		BG_omk19,
		BG_ev54,
		BG_ev55a,
		BG_ev55b,
		BG_ev56a,
		BG_ev56b,
		BG_ev57,
		BG_ev59a,
		BG_ev59b,
		BG_ev60,
		BG_ev61,
		BG_ev62a,
		BG_ev62b,
		BG_ev63,
		BG_ev64,
		BG_ev65,
		BG_ev66,
		BG_ev67a,
		BG_ev67b,
		BG_ev68,
		BG_ev69,
		BG_ev70,
		BG_ev71,
		BG_ev72,
		BG_ev73,
	},
	g_va_list[ALBUM_LIST_VA] = 
	{
		// oJX摜
		BG_va01,
		BG_va02,
		BG_va03,
		BG_va04,
		BG_va05,
		BG_va06,
		BG_va07,
		BG_va08,
		BG_va09,
		BG_va10,
		BG_va11,
		BG_va12,
		BG_va13,
		BG_va14,
		BG_va15,
		BG_va16,
		BG_va17,
		BG_va18,
		BG_va19,
		BG_va20,
		BG_va21,
		BG_va22,
		BG_va23,
		BG_va24,
		BG_va25,
		BG_va26,
		BG_va27,
		BG_va28,
		BG_va29,
		BG_va30,
		BG_va31,
		BG_va32,
	},
	g_ed_list[ALBUM_LIST_ED] = 
	{
		// GfBO摜
		BG_ed01,
		BG_ed02,
		BG_ed03,
		BG_ed04,
		BG_ed05,
		BG_ed06,
		BG_ed07,
		BG_ed08,
		BG_ed09,
		BG_ed10,
		BG_ed11,
		BG_ed12,
		BG_ed13,
		BG_ed14,
		BG_ed15,
		BG_ed16,
		BG_ed17,
		BG_ed18,
		BG_ed19,
		BG_ed20,
		BG_ed21,
		BG_ed22,
		BG_ed23,
		BG_ed24,
		BG_ed25,
		BG_ed26,
		BG_ed27,
		BG_ed28,
		BG_ed29,
		BG_ed30,
		BG_ed31,
		BG_ed32,
		BG_ed33,
		BG_ed34,
		BG_ed35,
		BG_ed36,
		BG_ed37,
		BG_ed38,
		BG_ed39,
		BG_ed40,
		BG_ed41,
		BG_ed42,
		BG_ed43,
	},
	g_tpd_list[] = 
	{
		_ALBUM_A1_TPD,
		_ALBUM_A2_TPD,
		_ALBUM_A3_TPD,
		_ALBUM_A4_TPD,
		_ALBUM_A5_TPD,
		_ALBUM_A6_TPD,
		_ALBUM_A7_TPD,
		_ALBUM_A8_TPD,
		_ALBUM_A9_TPD,
	};

static OamData
	g_album_oam[] =
	{
		// [Cxg]
		{    0,0,0,0,0,1,  12,0,0,0,3,   0/4,0, 1,0 },
		{    0,0,0,0,0,2,  76,0,0,0,2,  32/4,0, 1,0 },
		// [oJX]
		{    0,0,0,0,0,1,  84,0,0,0,3,  40/4,0, 1,0 },
		{    0,0,0,0,0,2, 148,0,0,0,2,  72/4,0, 1,0 },
		// [GfBO]
		{    0,0,0,0,0,1, 156,0,0,0,3,  80/4,0, 1,0 },
		{    0,0,0,0,0,2, 220,0,0,0,2, 112/4,0, 1,0 },
		// [g]
		{    0,0,0,0,0,1,   0,0,0,0,1, 120/4,0, 2,0 },
		{    0,0,0,0,0,1,  32,0,0,0,1, 124/4,0, 2,0 },
		{    8,0,0,0,0,2,   0,0,0,0,1, 128/4,0, 2,0 },
		{    8,0,0,0,0,2,  48,0,0,0,2, 132/4,0, 2,0 },
		{   40,0,0,0,0,0,   0,0,0,0,0, 140/4,0, 2,0 },
		{   32,0,0,0,0,1,   8,0,0,0,2, 144/4,0, 2,0 },
		{   32,0,0,0,0,2,  40,0,0,0,0, 152/4,0, 2,0 },
		{   40,0,0,0,0,1,  48,0,0,0,0, 156/4,0, 2,0 },
		// [E]
		{   76,0,0,0,0,2,   8,0,0,0,2, 160/4,0, 3,0 },	//5
		{   76,0,0,0,0,2,  24,0,0,0,1, 168/4,0, 3,0 },	//7
		{  108,0,0,0,0,0,   8,0,0,0,1, 172/4,0, 3,0 },
		{  108,0,0,0,0,2,  24,0,0,0,0, 176/4,0, 3,0 },
		{   76,0,0,0,0,2, 228,0,0,0,2, 180/4,0, 3,0 },	//9
		{  108,0,0,0,0,0, 228,0,0,0,1, 188/4,0, 3,0 },
		{   84,0,0,0,0,2, 244,0,0,0,1, 192/4,0, 3,0 },
		// [߂]
		{  173,0,0,0,0,1, 184,0,0,0,2, 196/4,0, 4,0 },
		// []
		{    0,0,0,0,0,2,   0,0,0,0,0, 204/4,0, 5,0 },
		{    0,0,0,0,0,2,   0,0,0,0,0, 208/4,0, 5,0 },	//11
		{    0,0,0,0,0,2,   0,0,0,0,0, 212/4,0, 5,0 },	//13
		{    0,0,0,0,0,2,   0,0,0,0,0, 216/4,0, 5,0 },	//15
		{    0,0,0,0,0,2,   0,0,0,0,0, 220/4,0, 5,0 },	//17
		{    0,0,0,0,0,2,   0,0,0,0,0, 224/4,0, 5,0 },	//19
		{    0,0,0,0,0,2,   0,0,0,0,0, 228/4,0, 5,0 },	//21
		{    0,0,0,0,0,2,   0,0,0,0,0, 232/4,0, 5,0 },	//23
		{    0,0,0,0,0,2,   0,0,0,0,0, 236/4,0, 5,0 },	//25
		{    0,0,0,0,0,2,   0,0,0,0,0, 240/4,0, 5,0 },	//27
		// [Cxg]
		{    5,0,0,0,0,1,  22,0,0,0,2, 244/4,0, 7,0 },
		{    5,0,0,0,0,1,  54,0,0,0,2, 252/4,0, 7,0 },	//29
		// [oJX]
		{    5,0,0,0,0,1,  94,0,0,0,2, 260/4,0, 7,0 },
		{    5,0,0,0,0,1, 126,0,0,0,2, 268/4,0, 7,0 },
		// [GfBO]
		{    5,0,0,0,0,1, 166,0,0,0,2, 276/4,0, 7,0 },
		{    5,0,0,0,0,1, 198,0,0,0,2, 284/4,0, 7,0 },
		// [t^]
		{    0,0,0,0,0,1,   0,0,0,0,3, 292/4,0, 6,0 },
		{   32,0,0,0,0,1,   0,0,0,0,2, 324/4,0, 6,0 },
		{   32,0,0,0,0,1,  32,0,0,0,2, 332/4,0, 6,0 },
		// [AoG]
		{   34,0,0,0,1,0,  34,0,0,0,3, 340/4,0, 0,0 },
		{   34,0,0,0,1,0, 102,0,0,0,3, 468/4,0, 0,0 },
		{   34,0,0,0,1,0, 170,0,0,0,3, 596/4,0, 0,0 },
		{   82,0,0,0,1,0,  34,0,0,0,3, 724/4,0, 0,0 },
		{   82,0,0,0,1,0, 102,0,0,0,3, 852/4,0, 0,0 },
		{   82,0,0,0,1,0, 170,0,0,0,3, 980/4,0, 0,0 },
		{  130,0,0,0,1,0,  34,0,0,0,3,1108/4,0, 0,0 },
		{  130,0,0,0,1,0, 102,0,0,0,3,1236/4,0, 0,0 },
		{  130,0,0,0,1,0, 170,0,0,0,3,1364/4,0, 0,0 },
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void initAlbumScreen(void);
static void waitAlbumMode(void);
static void mainAlbumMode(void);
static void decideAlbumMode(void);
static void transAlbumMode(void);
static void albumObjPut(int);
static void setAlbumData(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initAlbum(void)
{
	g_step = ALBUM_MODE_INIT;
}

// -------------------------------------
//  C
// -------------------------------------
void execAlbum(void)
{
	switch (g_step)
	{
		case ALBUM_MODE_INIT:
			initAlbumScreen();
			break;
		case ALBUM_MODE_WAIT:
			waitAlbumMode();
			break;
		case ALBUM_MODE_MAIN:
			mainAlbumMode();
			break;
		case ALBUM_MODE_DECIDE:
			decideAlbumMode();
			break;
		case ALBUM_MODE_TRANS:
			transAlbumMode();
			break;
		default:
			;
	}
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initAlbumScreen(void)
{
	putLCDC(0, 0);
	setMainLCDC(LCDC_UP);		// Cɂ
	setVRAMBank(VRAM_SIZE_256, VRAM_SIZE_64, VRAM_SIZE_128, VRAM_SIZE_128);
	setExtPalette(FALSE, FALSE, FALSE, TRUE);
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	// 
	createBmpBuf();		// _uobt@ł
	flipBmpBuf(0);

	readFile(_ALBUM_TITLEBG_CGB, &g_bg_buf);
	readBmpPtrToBmpPtr(g_bg_buf, getBmpBuf());
	freeBDS(g_bg_buf);
	g_bg_buf = NULL;
	flipBmpBuf(60);

	// 
	setFadeFrom(FADE_SUB_BG|FADE_SUB_OBJ, FADE_WHITE, FADE_NORMAL, 60);

	setObjCharMap(PLANE_SUB_OBJ, 4);
	setBgMode(PLANE_SUB_BG3, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);

	readFileToVRAM(_ALBUM_BG_CG, VRAM_SUB_BG3_CG, 0);
	readFileToVRAM(_ALBUM_BG_MAP, VRAM_SUB_BG3_SCR, 0);
	readFileToVRAM(_ALBUM_BG_PAL, VRAM_SUB_BG_PAL, 0);

	readFileToVRAM(_ALBUM_OBJ_CG, VRAM_SUB_OBJ_CG, 0);
	readFileToVRAM(_ALBUM_OBJ_PAL, VRAM_SUB_OBJ_PAL, 0);
	setFileToExtPalette(VRAM_SUB_OBJ_PAL, 0, _S_EV1_PAL);
	setFileToExtPalette(VRAM_SUB_OBJ_PAL, 1, _S_EV2_PAL);
	setFileToExtPalette(VRAM_SUB_OBJ_PAL, 2, _S_VA_PAL);
	setFileToExtPalette(VRAM_SUB_OBJ_PAL, 3, _S_ED_PAL);

	g_tag = 0;
	g_ev_page = 0;
	g_va_page = 0;
	g_ed_page = 0;

	albumObjPut(-1);

	setVisible(PLANE_MAIN_OBJ|PLANE_SUB_BG3|PLANE_SUB_OBJ, 1);

	putLCDC(1, 1);

	setBGM(SEQ_PRM4_23);
	playBGM();

	usePadRepeat(PAD_BUTTON_X, TRUE);
	g_step = ALBUM_MODE_WAIT;
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitAlbumMode(void)
{
	if (!isFlipBmpBuf())
	{
		setAlbumData();
		g_step = ALBUM_MODE_MAIN;
	}
	execBmpBuf();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainAlbumMode(void)
{
	s16 decide, select, selold;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
		{
			g_decide = 0;
			g_wait = 0;
			playSE(SE_03);
			fadeBGM(60);
			g_step = ALBUM_MODE_DECIDE;
		} else
		if (decide <= 3)
		{
			if (g_tag != decide - 1)
			{
				g_tag = (u8)(decide - 1);
				albumObjPut(-1);
				playSE(SE_02);
				setAlbumData();
			}
		} else
		if (decide == 4)
		{
			albumObjPut(4);
			playSE(SE_02);
			if (g_tag == 0)
			{
				if (g_ev_page == 0)
					g_ev_page = ((ALBUM_LIST_EV + 8) / 9) - 1;
				else
					g_ev_page--;
			} else
			if (g_tag == 1)
			{
				if (g_va_page == 0)
					g_va_page = ((ALBUM_LIST_VA + 8) / 9) - 1;
				else
					g_va_page--;
			} else {
				if (g_ed_page == 0)
					g_ed_page = ((ALBUM_LIST_ED + 8) / 9) - 1;
				else
					g_ed_page--;
			}
			g_step = ALBUM_MODE_TRANS;
		} else
		if (decide == 5)
		{
			albumObjPut(5);
			playSE(SE_02);
			if (g_tag == 0)
			{
				if (g_ev_page == ((ALBUM_LIST_EV + 8) / 9) - 1)
					g_ev_page = 0;
				else
					g_ev_page++;
			} else
			if (g_tag == 1)
			{
				if (g_va_page == ((ALBUM_LIST_VA + 8) / 9) - 1)
					g_va_page = 0;
				else
					g_va_page++;
			} else {
				if (g_ed_page == ((ALBUM_LIST_ED + 8) / 9) - 1)
					g_ed_page = 0;
				else
					g_ed_page++;
			}
			g_step = ALBUM_MODE_TRANS;
		} else
		if (decide >= 6 && decide <= 14)
		{
			if (getAlbum(g_bg_list[decide-6]))
			{
				readFile(getBgID(g_bg_list[decide-6]), &g_bg_buf);
				readBmpPtrToBmpPtr(g_bg_buf, getBmpBuf());
				freeBDS(g_bg_buf);
				g_bg_buf = NULL;
				flipBmpBuf(30);

				g_wait = 0;
				playSE(SE_02);
				g_decide = (u8)(decide - 5);
				g_step = ALBUM_MODE_DECIDE;
			} else {
				playSE(SE_06);
			}
		}
	} else
	if (select != selold)
	{
		if (select != -1)
		{
			if (g_tag != select - 1)
				playSE(SE_01);
		}
		albumObjPut(select);
	}
	execBmpBuf();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void decideAlbumMode(void)
{
	g_wait++;
	if (g_wait % 8 == 0)
	{
		clearObjDatas(SUB_OBJ+2, 8);
	} else
	if (g_wait % 4 == 0)
	{
		if (g_decide == 0)
			albumObjPut(0);
		else
			albumObjPut(g_decide+5);
	} else
	if (g_wait > 40)
	{
		clearObjDatas(SUB_OBJ+2, 8);
		if (g_decide == 0)
		{
			stopBGM();
			usePadRepeat(PAD_BUTTON_X, FALSE);
			changeGameMode(GAME_MODE_OMAKE);
		} else {
			albumObjPut(-1);
			g_step = ALBUM_MODE_MAIN;
		}
	}
	execBmpBuf();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void transAlbumMode(void)
{
	setAlbumData();
	albumObjPut(-1);
	g_step = ALBUM_MODE_MAIN;
	execBmpBuf();
}


// -------------------------------------
//  nai\
// -------------------------------------
static void albumObjPut(int in_num)
{
	int page, pagemax;

	clearObjDatas(SUB_OBJ+2, 8);
	if (g_tag == 0)
		setObjData(SUB_OBJ+0, (void *)&g_album_oam[0], 2);
	else
	if (in_num == 1)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[32], 2);
	if (g_tag == 1)
		setObjData(SUB_OBJ+0, (void *)&g_album_oam[2], 2);
	else
	if (in_num == 2)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[34], 2);
	if (g_tag == 2)
		setObjData(SUB_OBJ+0, (void *)&g_album_oam[4], 2);
	else
	if (in_num == 3)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[36], 2);

	if (in_num == 0)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[21], 1);
	else
	if (in_num == 4)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[14], 4);
	else
	if (in_num == 5)
		setObjData(SUB_OBJ+2, (void *)&g_album_oam[18], 3);
	else
	if (in_num >= 6 && in_num <= 14)
		setObjDataPos(SUB_OBJ+2, (void *)&g_album_oam[6], 8, 29+((in_num-6)%3)*68, 30+((in_num-6)/3)*48);

	if (g_tag == 0)
	{
		page = g_ev_page + 1;
		pagemax = (ALBUM_LIST_EV + 8) / 9;
	} else
	if (g_tag == 1)
	{
		page = g_va_page + 1;
		pagemax = (ALBUM_LIST_VA + 8) / 9;
	} else {
		page = g_ed_page + 1;
		pagemax = (ALBUM_LIST_ED + 8) / 9;
	}
	if (page >= 10)
		setObjDataPos(SUB_OBJ+10, (void *)&g_album_oam[22+(page/10)], 1, 107, 176);
	else
		clearObjData(SUB_OBJ+10);
	setObjDataPos(SUB_OBJ+11, (void *)&g_album_oam[22+(page%10)], 1, 115, 176);
	if (pagemax >= 10)
		setObjDataPos(SUB_OBJ+12, (void *)&g_album_oam[22+(pagemax/10)], 1, 135, 176);
	else
		clearObjData(SUB_OBJ+12);
	setObjDataPos(SUB_OBJ+13, (void *)&g_album_oam[22+(pagemax%10)], 1, 143, 176);










}

// -------------------------------------
//  AoZbeBO
// -------------------------------------
static void setAlbumData(void)
{
	int page, pagemax, count, i, ofs, pal;
	void *ptr;
	u16 *list;

	clearObjDatas(SUB_OBJ+14, 9*3);

	if (g_tag == 0)
	{
		page = g_ev_page + 1;
		pagemax = (ALBUM_LIST_EV + 8) / 9;
		count = (ALBUM_LIST_EV % 9);
		list = g_ev_list;
		if (page <= 6)
		{
			readFile(_S_EV1_CG, &ptr);
			ofs = 0;
			pal = 0;
		} else {
			readFile(_S_EV2_CG, &ptr);
			ofs = -0x36000;
			pal = 1;
		}
	} else
	if (g_tag == 1)
	{
		page = g_va_page + 1;
		pagemax = (ALBUM_LIST_VA + 8) / 9;
		count = (ALBUM_LIST_VA % 9);
		list = g_va_list;
		readFile(_S_VA_CG, &ptr);
		ofs = 0;
		pal = 2;
	} else {
		page = g_ed_page + 1;
		pagemax = (ALBUM_LIST_ED + 8) / 9;
		count = (ALBUM_LIST_ED % 9);
		list = g_ed_list;
		readFile(_S_ED_CG, &ptr);
		ofs = 0;
		pal = 3;
	}
	if (page != pagemax)
		count = 9;
	if (count == 0)
		count = 9;

	transToVRAM(VRAM_SUB_OBJ_CG, (void *)((u32)ptr+(page-1)*0x9000+ofs), (u32)count*0x1000, 0x2a80);
	freeBDS(ptr);
	ptr = NULL;

	for (i=0; i<9; i++)
	{
		if (i < count)
		{
			g_bg_list[i] = list[(page-1)*9 + i];
			if (getAlbum(g_bg_list[i]))
				setObjDataPal(SUB_OBJ+14+i*3, (void *)&g_album_oam[41+i], 1, pal);
		} else {
			setObjDataPos(SUB_OBJ+14+i*3, (void *)&g_album_oam[38], 3, 32+(i%3)*68, 32+(i/3)*48);
			g_bg_list[i] = 0;
		}
	}

	initTouchPenData();
	setTouchPenData(g_tpd_list[count-1]);
	setTouchPenKeySelectPos(6);
	setTouchPenKeyDecide(PAD_BUTTON_B, 0);
	setTouchPenKeyDecide(PAD_BUTTON_L, 4);
	setTouchPenKeyDecide(PAD_BUTTON_R, 5);
	if (g_tag == 0)
	{
		setTouchPenKeyDecide(PAD_BUTTON_X, 2);
		setTouchPenKeyDecide(PAD_BUTTON_Y, 3);
	} else
	if (g_tag == 1)
	{
		setTouchPenKeyDecide(PAD_BUTTON_X, 3);
		setTouchPenKeyDecide(PAD_BUTTON_Y, 1);
	} else {
		setTouchPenKeyDecide(PAD_BUTTON_X, 1);
		setTouchPenKeyDecide(PAD_BUTTON_Y, 2);
	}
}
