//---------------------------------------------------------------------------
//
//	׊w
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "sound_data.h"
#include "game.h"
#include "map.h"
#include "graph.h"
#include "prime4.h"
#include "event_grp.h"
#include "map_script.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define MAP_MODE_NONE			0		// ҋ@
#define MAP_MODE_PUT_COUNTER	1		// JE^\
#define MAP_MODE_SELECT			2		// I
#define MAP_MODE_DECIDE			3		// 
#define MAP_MODE_WAIT_DIALOG	4		// _CAO\
#define MAP_MODE_DIALOG			5		// _CAO
#define MAP_MODE_END_DIALOG		6		// _CAOI

#define MAP_MODE_WAIT_CASTLE	7		// I̕\҂
#define MAP_MODE_MAIN_CASTLE	8		// I
#define MAP_MODE_DECIDE_CASTLE	9		// I

// -------------------------------------
// NXE\̒`
// -------------------------------------

// -------------------------------------
// [Jϐ`
// -------------------------------------
static s8
	g_map_select;
static u8
	g_step,
	g_dialog_decide,
	g_map,
	g_map_type,
	g_mapMoveCount,
	g_decide_count,
	g_dark_castle,
	g_castle_pos,
	*g_map_num_table;
static u16
	g_castle_tpd;
static char
	g_guide_mes1[] = "H",
	g_guide_mes2[] = "̃lCTlH",
	g_guide_mes3[] = "ohݗlH",
	g_guide_mes4[] = "gXilH",
	g_guide_mes5[] = "b̃IYhlH",
	g_guide_mes6[] = "ܗlƂȂ̂H",
	g_guide_mes7[] = "Éɉ̂H",
	g_guide_mesA[] = "傤ǘb񂾂B",
	g_guide_mesB[] = "ĂƂccB",
	g_guide_mesC[] = "ΌNɘbƂccB",
	g_dark_guide_mes1[] = "킽łH",
	g_dark_guide_mes2[] = "B[iał܂H",
	g_dark_guide_mes3[] = "K[hlłȁH",
	g_dark_guide_mes4[] = "OCglłȁH",
	g_dark_guide_mes5[] = "Éł܂ccB",
	g_dark_guide_mesA[] = "łˁAb܂B",
	g_dark_guide_mesB[] = "ŋ߂ZlqłccB",
	g_dark_guide_mesC[] = "ĂbȂƂłB";
static s8
	g_map_number[] = 
		{ -1, 6, 3, 8, 9, 2, 10, 0, 1, 5, 4, 7, 11, 13, 12, 16, 15, 14 },
	g_dark_castle_ch[4][3] = 
	{
		{  2,  3, -1 },
		{  3, -1, -1 },
		{  2,  3,  4 },
		{  3,  4, -1 }
	};
static u8
	g_map_num_0[] = 
		{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 },
	g_map_num_1a[] = 
		{ 0, 12, 13, 14, 15 },
	g_map_num_1b[] = 
		{ 0, 12, 13, 16, 14, 15 },
	g_map_num_1c[] = 
		{ 0, 12, 13, 17, 14, 15 },
	g_map_num_1d[] = 
		{ 0, 12, 13, 16, 18, 14, 15 };
static u16
	g_map_tpd[] = 
	{
		_MAP_MENU_1_TPD,
		_MAP_MENU_2A_TPD,
		_MAP_MENU_2B_TPD,
		_MAP_MENU_2C_TPD,
		_MAP_MENU_2D_TPD,
	},
	g_dark_castle_tpd[] = 
	{
		_CASTLE_MENU_3_TPD,
		_CASTLE_MENU_2_TPD,
		_CASTLE_MENU_4_TPD,
		_CASTLE_MENU_3_TPD,
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void selectMapSelect(void);
static void waitMapDialog(void);
static void mainMapDialog(void);
static void endMapDialog(void);
static void waitCastleSelect(void);
static void mainCastleSelect(void);
static void mainCastleDecide(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//	
// -------------------------------------
void initMapSelect(void)
{
	g_step = MAP_MODE_NONE;
}

// -------------------------------------
//	}bvI
// -------------------------------------
void initSelectMap(void)
{
	g_map = MAP_TYPE_TOWN;
	g_mapMoveCount = 3;

	//#{ $mapExitMode = OFF }
	//#{ $mapKind = 0 }
	//#{ $GateTravel = 0 }
	//#{ $ev30Count = 0 }
	setLabel(LF_adv02_5_hint_disable, OFF);

	setSelectMap();
}

// -------------------------------------
//	}bv\
// -------------------------------------
void setSelectMap(void)
{
	setBGM(SEQ_PRM4_33);
	playBGM();
	setChangeLock(TRUE);
	clearCha(3);
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	putDateWindow(FALSE);
	if (g_map == MAP_TYPE_TOWN)
	{
		g_map_type = 0;
		setBgNum(BG_map01);
	} else {
		g_map_type = (u8)(getDarkMapType() + 1);
		if (g_map_type <= 2)
			setBgNum(BG_map02a);		// Ɩ
		else
			setBgNum(BG_map02b);		// Ƃ
	}
	setChangeLock(FALSE);
	waitChangeGraph();
	waitOnly(10);
}

// -------------------------------------
//	}bvIJn
// -------------------------------------
void startMapSelect(void)
{
	if (g_map != MAP_TYPE_TOWN)
	{
		// XȂꍇ͕ύX̉\
		g_map_type = (u8)(getDarkMapType() + 1);
		setMapDarkGraph((u8)(g_map_type-1));
		if (g_map_type == 1)
			g_map_num_table = g_map_num_1a;
		else
		if (g_map_type == 2)
			g_map_num_table = g_map_num_1b;
		else
		if (g_map_type == 3)
			g_map_num_table = g_map_num_1c;
		else
			g_map_num_table = g_map_num_1d;
	} else {
		setMapTownGraph();
		g_map_num_table = g_map_num_0;
	}

	putDokoiku(TRUE);
	waitChangeGraph();
	waitOnly(10);

	if (g_map == MAP_TYPE_TOWN)
		putMapCounter(0, g_mapMoveCount);
	else
		putMapCounter(1, g_mapMoveCount);

	g_step = MAP_MODE_PUT_COUNTER;
}

// -------------------------------------
//	C
// -------------------------------------
void execMapSelect(void)
{
	switch (g_step)
	{
		case MAP_MODE_NONE:
			break;
		case MAP_MODE_PUT_COUNTER:
			if (!isChangeSubGraph())
			{
				initTouchPenData();
				setTouchPenData(g_map_tpd[g_map_type]);
				setTouchPenKeySelectPos(1);
				//setTouchPenKeyDecide(PAD_BUTTON_B, 0);
				g_step = MAP_MODE_SELECT;
			}
			break;
		case MAP_MODE_SELECT:
			selectMapSelect();
			break;
		case MAP_MODE_DECIDE:
			if (!isChangeSubGraph() && !isFlipBmpBuf())
			{
				
				
				// I胋[`
				g_mapMoveCount--;
				g_step = MAP_MODE_NONE;
			}
			break;
		case MAP_MODE_WAIT_DIALOG:
			waitMapDialog();
			break;
		case MAP_MODE_DIALOG:
			mainMapDialog();
			break;
		case MAP_MODE_END_DIALOG:
			endMapDialog();
			break;
		case MAP_MODE_WAIT_CASTLE:
			waitCastleSelect();
			break;
		case MAP_MODE_MAIN_CASTLE:
			mainCastleSelect();
			break;
		case MAP_MODE_DECIDE_CASTLE:
			mainCastleDecide();
			break;
	}
}

// -------------------------------------
//	҂
// -------------------------------------
void waitMapSelect(void)
{
	while (g_step != MAP_MODE_NONE || isChangeSubGraph() || isFlipBmpBuf())
		OS_Sleep(100);
}

// -------------------------------------
//	I
// -------------------------------------
static void selectMapSelect(void)
{
	s16 decide, select, selold;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
			playSE(SE_06);
		else
			playSE(SE_05);
		if (decide == 0 && g_map == MAP_TYPE_TOWN)
		{
			putMapPos(-1);
			putMapSelectObj(0);
			setSubDialog();
			g_step = MAP_MODE_WAIT_DIALOG;
		} else {
			g_map_select = (s8)g_map_num_table[decide];
			if (g_map_select == 18)
				g_map_select = 17;
			decideMap((s8)(g_map_select-1));
			setScriptGraph();
			putMapSelectObj(-1);
			g_step = MAP_MODE_DECIDE;
		}
	} else
	if (select != selold)
	{
		putDokoiku(FALSE);
		if (select == -1)
		{
			putMapPos(-1);
			putMapSelectObj(-1);
		} else {
			playSE(SE_04);
			putMapPos((s8)(g_map_num_table[select] - 1));
			putMapSelectObj((s8)g_map_num_table[select]);
		}
	}
}

// -------------------------------------
//	݂̃}bv^Cv
// -------------------------------------
u8 getMapType(void)
{
	return g_map;
}

// -------------------------------------
//	Ẽ}bv^Cv
// -------------------------------------
u8 getDarkMapType(void)
{
	BOOL dragon, ork;
	u8 result;

	dragon = checkDragon();
	ork = checkOrk();
	if (!ork)
	{
		if (!dragon)
			result = 0;		//a
		else
			result = 1;		//b
	} else {
		if (!dragon)
			result = 2;		//c
		else
			result = 3;		//d
	}
	return result;
}

// -------------------------------------
//	}bvI
// -------------------------------------
s8 getMapResult(void)
{
	return g_map_number[g_map_select];
}

// -------------------------------------
//	}bvI
// -------------------------------------
u8 getMapMoveCount(void)
{
	return g_mapMoveCount;
}
// -------------------------------------
void setMapMoveCount(u8 in_count)
{
	g_mapMoveCount = in_count;
}
// -------------------------------------
//	}bv\
// -------------------------------------
void setMapBg(void)
{
	if (g_map == MAP_TYPE_TOWN)
	{
		setBgNum(BG_map01);
	} else {
		if (g_map_type <= 2)
			setBgNum(BG_map02a);		// Ɩ
		else
			setBgNum(BG_map02b);		// Ƃ
	}
	waitChangeGraph();
}

// -------------------------------------
//	}bv_CAO
// -------------------------------------
static void waitMapDialog(void)
{
	if (isPutSubDialog())
	{
		initTouchPenData();
		setTouchPenData(_ENTRY_DIALOG_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_B, 1);
		setTouchPenKeyDecide(PAD_BUTTON_START, 0);
		setTouchPenKeySelectPos(1);

		g_step = MAP_MODE_DIALOG;
	}
}
// -------------------------------------
static void mainMapDialog(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide == 0)
	{
		playSE(SE_02);
		g_dialog_decide = 0;
		decideSubDialog(0);
		g_step = MAP_MODE_END_DIALOG;
	} else
	if (decide == 1)
	{
		playSE(SE_03);
		g_dialog_decide = 1;
		decideSubDialog(1);
		g_step = MAP_MODE_END_DIALOG;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		selectSubDialog(select);
	}
}
// -------------------------------------
static void endMapDialog(void)
{
	if (isDeleteSubDialog())
	{
		if (g_dialog_decide == 0)
		{
			// ͂
			g_map_select = 0;
			setScriptGraph();
			g_step = MAP_MODE_DECIDE;
		} else {
			// 
			putMapSelectObj(-1);
			initTouchPenData();
			setTouchPenData(g_map_tpd[g_map_type]);
			setTouchPenKeySelectPos(1);
			//setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = MAP_MODE_SELECT;
		}
	}
}

// -------------------------------------
//	I
// -------------------------------------
void setCastleSelect(void)
{
	setMapCastleGraph();
	g_castle_tpd = _CASTLE_MENU_1_TPD;
	g_castle_pos = 0;
	g_step = MAP_MODE_WAIT_CASTLE;
}
// -------------------------------------
void setDarkCastleSelect(u8 in_dc)
{
	setMapDarkCastleGraph(g_dark_castle_ch[in_dc][0], g_dark_castle_ch[in_dc][1], g_dark_castle_ch[in_dc][2]);
	g_castle_tpd = g_dark_castle_tpd[in_dc];
	g_dark_castle = in_dc;
	g_castle_pos = 1;
	g_step = MAP_MODE_WAIT_CASTLE;
}
// -------------------------------------
static void waitCastleSelect(void)
{
	if (!isChangeSubGraph())
	{
		initTouchPenData();
		setTouchPenData(g_castle_tpd);
		g_step = MAP_MODE_MAIN_CASTLE;
	}
}
// -------------------------------------
static void mainCastleSelect(void)
{
	s16 decide, select, selold;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		g_map_select = (s8)decide;
		g_decide_count = 32;
		clearMessage();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		g_step = MAP_MODE_DECIDE_CASTLE;
	} else
	if (select != selold)
	{
		if (g_map == MAP_TYPE_TOWN)
		{
			putMapCastleObj((s8)select);
			clearMessage();
			switch (select)
			{
				case 0:
					setMessage(0,  4*2, g_guide_mes1);
					if (ca01())
						setMessage(1, 12*2, g_guide_mesA);
					break;
				case 1:
					setMessage(0, 12*2, g_guide_mes2);
					if (getLabel(LF_ca01_7) == ON || getParam(pCHIMEI) >= 60)
					{
						if (ca02())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				case 2:
					setMessage(0, 11*2, g_guide_mes3);
					if (getParam(pKIHINN) >= 60 && (getLabel(LF_ca02_2) == ON || getParam(pCHIMEI) >= 60))
					{
						if (ca03())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				case 3:
					setMessage(0,  9*2, g_guide_mes4);
					if (getParam(pMORAL) >= 90 && (getLabel(LF_ca03_2) == ON || getParam(pCHIMEI) >= 120))
					{
						if (ca04())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				case 4:
					setMessage(0, 12*2, g_guide_mes5);
					if (getLabel(LF_ca04_2) == ON && getParam(pKIHINN) >= 120)
					{
						if (ca05())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				case 5:
					setMessage(0, 13*2, g_guide_mes6);
					if (getLabel(LF_ca05_2) == ON)
					{
						if (ca06())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				case 6:
					setMessage(0, 13*2, g_guide_mes7);
					if (getLabel(LF_ca06_2) == ON && getParam(pKIHINN) >= 180)
					{
						if (ca07())
							setMessage(1, 16*2, g_guide_mesC);
					} else
						setMessage(1, 14*2, g_guide_mesB);
					break;
				default:
					;
			}
			putStartMessage();
		} else {
			putMapDarkCastleObj((s8)select);
			clearMessage();
			if (select == 0)
			{
				setMessage(0,  8*2, g_dark_guide_mes1);
				if (ac01())
					setMessage(1, 15*2, g_dark_guide_mesA);
			} else
			if (select == 1)
			{
				setMessage(0,  13*2, g_dark_guide_mes2);
				if (ac02())
					setMessage(1, 16*2, g_dark_guide_mesC);
			} else
			if (select != -1)
			{
				switch (g_dark_castle_ch[g_dark_castle][select-2])
				{
					case 2:
						setMessage(0,  10*2, g_dark_guide_mes3);
						if (ac03())
							setMessage(1, 16*2, g_dark_guide_mesC);
						break;
					case 3:
						setMessage(0,  10*2, g_dark_guide_mes4);
						if (ac04())
							setMessage(1, 16*2, g_dark_guide_mesC);
						break;
					case 4:
						setMessage(0,  12*2, g_dark_guide_mes5);
						if (getLabel(LF_ev032) == OFF && getLabel(LF_ev085) == ON)
							setMessage(1, 16*2, g_dark_guide_mesB);
						if (ac05())
							setMessage(1, 16*2, g_dark_guide_mesC);
						else
							setMessage(1, 16*2, g_dark_guide_mesB);
						break;
					default:
						;
				}
			}
			putStartMessage();
		}
	}
}
// -------------------------------------
static void mainCastleDecide(void)
{
	g_decide_count--;
	if ((g_decide_count / 4) % 2 == 0)
	{
		if (g_map == MAP_TYPE_TOWN)
			putMapCastleObj(-1);
		else
			putMapDarkCastleObj(-1);
	} else {
		if (g_map == MAP_TYPE_TOWN)
			putMapCastleObj(g_map_select);
		else
			putMapDarkCastleObj(g_map_select);
	}
	if (g_decide_count == 0)
	{
		setParamGraph();
		g_step = MAP_MODE_NONE;
	}
}

// -------------------------------------
//	I
// -------------------------------------
s8 getCastleResult(void)
{
	if (g_castle_pos == 0 || g_map_select < 2)
		return g_map_select;
	return g_dark_castle_ch[g_dark_castle][g_map_select-2];
}

// -------------------------------------
//	}bvύX
// -------------------------------------
void changeMap(void)
{
	if (g_map == MAP_TYPE_TOWN)
		g_map = MAP_TYPE_DARK;
	else
		g_map = MAP_TYPE_TOWN;
	// }bvύXmapMoveCount߂
	g_mapMoveCount++;
}
