//---------------------------------------------------------------------------
//
//	XPW[ݒƎsӂ̏
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "sound_data.h"
#include "game.h"
#include "schedule.h"
#include "prime4.h"
#include "event_grp.h"
#include "script.h"
#include "va00.h"
#include "al00.h"
#include "tr00.h"
#include "sp01.h"
#include "map.h"
#include "map_script.h"
#include "item.h"
#include "fe00.h"
#include "ending.h"
#include "def/room_def.h"
#include "def/schedule_def.h"
#include "def/re01_def.h"
#include "def/re02_def.h"
#include "def/va00_def.h"
#include "def/adv01_def.h"
#include "def/adv02_def.h"
#include "def/at00_def.h"
#include "def/ev011_def.h"
#include "def/ev019_def.h"
#include "def/ev032_def.h"
#include "def/ev034_def.h"
#include "def/ev300_def.h"
#include "def/ev302_def.h"
#include "def/ev310_def.h"
#include "def/ev311_def.h"
#include "def/tk01_def.h"
#include "def/e_nfd_def.h"
#include "def/e_birth_def.h"
#include "def/e_holi_def.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define SCHEDULE_MODE_SET_WAIT		0		// XPW[ݒ\҂
#define SCHEDULE_MODE_SET_MAIN		1		// XPW[ݒ胁C
#define SCHEDULE_MODE_DIALOG_SET	2		// XPW[ݒ_CAO
#define SCHEDULE_MODE_DIALOG		3		// XPW[ݒ_CAO
#define SCHEDULE_MODE_DIALOG_DEL	4		// XPW[ݒ_CAO
#define SCHEDULE_MODE_SET_DECIDE	5		// XPW[
#define SCHEDULE_MODE_SET_END		6		// XPW[ݒ̏I
#define SCHEDULE_MODE_SET_CANCEL	7		// XPW[ݒ̃LZ
#define SCHEDULE_MODE_CANCEL		8		// LZ

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_schedule_day_put,
	g_schedule_NEM,
	g_gate_travel,
	g_schedule_end,
	g_schedule_cancel,
	g_ending_flag;
static u8
	g_step,
	g_count,
	g_schedule_tag,
	g_schedule_phase,
	g_schedule_decide,
	g_schedule_run_no,
	g_schedule_run_days,
	g_schedule_tmp_day,
	g_schedule_good,
	g_schedule_tmp_end,
	g_schedule[3],
	g_cursor_signal,
	g_cancel_num;
static s16
	g_wait,
	g_cursor_decide;
static s32
	g_gold_add_value,
	g_param_add_value[28],
	g_param_add_width[28],
	g_schedule_suc_per;

static s32
	g_schedule_tpd[] = 
	{
		_SCHEDULE_0_TPD,
		_SCHEDULE_1_TPD,
		_SCHEDULE_2_TPD,
		_SCHEDULE_3_TPD,
		_SCHEDULE_4_TPD,
		_SCHEDULE_5_TPD,
		_SCHEDULE_6_TPD,
		_SCHEDULE_7_TPD,
		_SCHEDULE_8_TPD,
		_SCHEDULE_9_TPD,
		_SCHEDULE_10_TPD,
		_SCHEDULE_11_TPD,
		_SCHEDULE_12_TPD,
		_SCHEDULE_13_TPD,
		_SCHEDULE_14_TPD,
	};

static OamData
	g_daughter_name_u_oam[] =
	{
		{   29,0,0,0,0,0, 128,0,0,0,1,  24,0, 0,0 },
		{   29,0,0,0,0,0, 142,0,0,0,1,  28,0, 0,0 },
		{   29,0,0,0,0,0, 156,0,0,0,1,  32,0, 0,0 },
		{   29,0,0,0,0,0, 170,0,0,0,1,  36,0, 0,0 },
		{   29,0,0,0,0,0, 184,0,0,0,1,  40,0, 0,0 },
		{   29,0,0,0,0,0, 198,0,0,0,1,  44,0, 0,0 },
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void waitScheduleSet(void);
static void execScheduleSet(void);
static void waitScheduleDialog(void);
static void mainScheduleDialog(void);
static void decideScheduleDialog(void);
static void decideScheduleSet(void);
static void setScheduleTpd(u8);
static void room_schedule(void);

static void schedule_exec(void);
static void decEv32(void);
static void funcClearAddParamValue(void);
static void funcSetFailureGold(void);
static void funcParamAddUpdate(void);
static void funcHalfParamAddValue(void);
static void funcSetAddParamValue(void);
static void schExecAl(void);
static void schExecSt(void);
static void schStartScr(void);
static void schEndScr(void);
static void GetSchSucessParsent(void);
static void NextDay(void);
static void decBirth(void);
static void cmdIncDay(void);
static void funcSetParamUpdateList(void);

static void schYasumi(void);
static int schYasumiEvent(void);
static void funcSetAddParamValueYasumi_0(void);
static void funcSetAddParamValueYasumi_1(void);
static void schRyouyou(void);
static void funcSetAddParamValueRyouyou_0(void);
static void funcSetAddParamValueRyouyou_1(void);
static void schBakansu(void);
static void schOdekake(void);

static void newScheduleGuide(void);
static void e_nfd(void);
static void e_birth(void);
static void e_holi(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  XPW[ݒ
// -------------------------------------
void initScheduleSet(void)
{
	g_schedule_cancel = FALSE;
	g_ending_flag = FALSE;
	setScriptThread(room_schedule);
	g_step = SCHEDULE_MODE_SET_WAIT;
}
// -------------------------------------
u8 mainScheduleSet(void)
{
	u8 result;

	result = 0;
	switch (g_step)
	{
		case SCHEDULE_MODE_SET_WAIT:
			waitScheduleSet();
			break;
		case SCHEDULE_MODE_SET_MAIN:
			execScheduleSet();
			break;
		case SCHEDULE_MODE_DIALOG_SET:
			waitScheduleDialog();
			break;
		case SCHEDULE_MODE_DIALOG:
			mainScheduleDialog();
			break;
		case SCHEDULE_MODE_DIALOG_DEL:
			decideScheduleDialog();
			break;
		case SCHEDULE_MODE_SET_DECIDE:
			decideScheduleSet();
			break;
		case SCHEDULE_MODE_SET_END:
			result = 1;
			break;
		case SCHEDULE_MODE_SET_CANCEL:
			if (!isChangeSubGraph())
				result = 2;
//			else
//				execEventGraph();
			break;
		case SCHEDULE_MODE_CANCEL:
			result = g_cancel_num;
			break;
		default:
			;
	}
	if (g_ending_flag)
	{
		//OS_ResetSystem(1);
		stopBGM();
		exitEventGraph();
		changeGameMode(GAME_MODE_ENDING);
		return 99;
	}
	return result;
}


// -------------------------------------
//  XPW[ݒʕ\҂
// -------------------------------------
static void waitScheduleSet(void)
{
	if (!isChangeSubGraph() && isEndScriptThread())
	{
		if (!g_schedule_cancel)
		{
			g_cursor_signal = 0;
			setScheduleTpd(0);
			g_schedule_end = FALSE;
			g_step = SCHEDULE_MODE_SET_MAIN;
		} else {
			setSkipFlag(FALSE);
			g_step = SCHEDULE_MODE_CANCEL;
		}
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  XPW[ݒ
// -------------------------------------
static void execScheduleSet(void)
{
	s16 decide, select, selold;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (g_cursor_signal > 0)
	{
		if (select != selold && !g_schedule_end)
		{
			g_cursor_signal = 0;
			setPutScheduleCursor(TRUE);
		} else {
			g_cursor_signal--;
			if ((g_cursor_signal / 4) % 2 == 0)
				setPutScheduleCursor(TRUE);
			else
				setPutScheduleCursor(FALSE);
			if (select != -1)
				putScheduleObj(g_schedule_tag, select);
			else
			if (g_cursor_signal == 0)
				putScheduleObj(g_schedule_tag, select);
			else
				putScheduleObj(g_schedule_tag, g_cursor_decide);
		}
		if (g_schedule_end)
		{
			if (g_cursor_signal == 0)
			{
				setSubDialog();
				g_step = SCHEDULE_MODE_DIALOG_SET;
			}
			return;
		}
	}
	if (decide != -1)
	{
		// 
		if (decide < 3)
		{
			// ؂ւ
			if (decide != g_schedule_tag)
			{
				playSE(SE_01);
				g_schedule_tag = (u8)decide;
				initScheduleObj(g_schedule_tag);
				putScheduleGold(g_schedule_phase, 0);
				setScheduleTpd(g_schedule_tag);
			}
		} else
		if (decide == 3)
		{
			playSE(SE_03);
			if (g_schedule_phase == 0)
			{
				// Cj[ɖ߂
				putScheduleObj(g_schedule_tag, -1);
				putScheduleCalendar(FALSE);
				setScriptGraph();
				g_step = SCHEDULE_MODE_SET_CANCEL;
			} else {
				putScheduleGold(g_schedule_phase, 0);
				g_schedule_phase--;
				updateScheduleCalendar(g_schedule_phase, 0);
				if (select < 4)
					putScheduleObj(g_schedule_tag, -1);
			}
		} else {
			playSE(SE_02);
			updateScheduleCalendar(g_schedule_phase, (u8)(getScheduleNum(decide-4)+1));
			g_schedule[g_schedule_phase] = getScheduleNum(decide-4);
			g_schedule_phase++;
			g_schedule_end = FALSE;
			if (g_schedule_phase == 3)
			{
				g_schedule_end = TRUE;
			} else
			if (select >= 4)
				putScheduleGold(g_schedule_phase, (u8)(getScheduleNum(select-4)+1));
			g_cursor_signal = 20;
			g_cursor_decide = decide;
		}
	} else {
		if (select != selold)
		{
			putScheduleObj(g_schedule_tag, select);
			if (select >= 4)
				putScheduleGold(g_schedule_phase, (u8)(getScheduleNum(select-4)+1));
			if (select != -1)
				playSE(SE_01);
		}
		if (!isSelectTouchPen())
			putScheduleAnimObj(g_schedule_tag, select);
	}
	if (getPadTrg() & PAD_BUTTON_Y)
	{
		playSE(SE_04);
		g_schedule_day_put = !g_schedule_day_put;
		setScheduleCalendarDayPut(g_schedule_day_put);
	}
	//execEventGraph();
}

// -------------------------------------
//  XPW[ݒ_CAO
// -------------------------------------
static void waitScheduleDialog(void)
{
	if (g_cursor_signal > 0)
	{
		g_cursor_signal--;
		if ((g_cursor_signal / 4) % 2 == 0)
			setPutScheduleCursor(TRUE);
		else
			setPutScheduleCursor(FALSE);
		if (g_cursor_signal == 0)
			putScheduleObj(g_schedule_tag, -1);
		else
			putScheduleObj(g_schedule_tag, g_cursor_decide);
	} else
	if (isPutSubDialog())
	{
		initTouchPenData();
		setTouchPenData(_ENTRY_DIALOG_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_B, 1);
		setTouchPenKeyDecide(PAD_BUTTON_START, 0);
		setTouchPenKeySelectPos(1);

		g_step = SCHEDULE_MODE_DIALOG;
	}
	//execEventGraph();
}
// -------------------------------------
static void mainScheduleDialog(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide == 0)
	{
		playSE(SE_02);
		g_schedule_decide = 0;
		decideSubDialog(0);
		g_step = SCHEDULE_MODE_DIALOG_DEL;
	} else
	if (decide == 1)
	{
		playSE(SE_03);
		g_schedule_decide = 1;
		decideSubDialog(1);
		g_step = SCHEDULE_MODE_DIALOG_DEL;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		selectSubDialog(select);
	}
	//execEventGraph();
}
// -------------------------------------
static void decideScheduleDialog(void)
{
	if (isDeleteSubDialog())
	{
		if (g_schedule_decide == 0)
		{
			putScheduleCalendar(FALSE);
			setParamGraph();
			g_step = SCHEDULE_MODE_SET_DECIDE;
		} else
		if (g_schedule_decide == 1)
		{
			if (g_schedule_phase == 3)
			{
				g_schedule_phase = 2;
				updateScheduleCalendar(g_schedule_phase, 0);
				putScheduleGold(g_schedule_phase, 0);
			}
			setScheduleTpd(g_schedule_tag);
			putScheduleObj(g_schedule_tag, -1);
			putScheduleAnimObj(g_schedule_tag, -1);
			g_step = SCHEDULE_MODE_SET_MAIN;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  XPW[ݒ^b`y
// -------------------------------------
static void setScheduleTpd(u8 in_tag)
{
	s16 padl, padr;

	if (in_tag == 0)
	{
		// ׋
		padl = 2;
		padr = 1;
	} else
	if (in_tag == 1)
	{
		// AoCg
		padl = 0;
		padr = 2;
	} else {
		// x
		padl = 1;
		padr = 0;
	}
	initTouchPenData();
	setTouchPenData(g_schedule_tpd[getScheduleTips()]);
	setTouchPenKeyDecide(PAD_BUTTON_B, 3);
	if (getScheduleTips() > 1)
	{
		setTouchPenKeyDecide(PAD_BUTTON_L, padl);
		setTouchPenKeyDecide(PAD_BUTTON_R, padr);
		setTouchPenKeyDecide(PAD_BUTTON_SELECT, padr);
	}
	if (getScheduleTips() == 0)
		setTouchPenKeySelectPos(-1);
	else
		setTouchPenKeySelectPos(4);
}

// -------------------------------------
// XPW[sJn
// -------------------------------------
static void decideScheduleSet(void)
{
	if (!isChangeSubGraph())
		g_step = SCHEDULE_MODE_SET_END;
	//execEventGraph();
}


//--------------------------------------
// XPW[
//--------------------------------------
static void room_schedule(void)
{
	int i;

// nՂ̓
// ŎnՔ̔s
// PJi߂Ă܂B
// ãCxǵA̍Ōɍs
///
	if (getMonth() == 9)
	{
		setLabel(LF_ha2_kr_victory, OFF);		// NX`[i_XReXgDtO
		if (getcon() == conS)
		{
			setParamGraph();
			fe_nw00_conS();
		} else {
			setScriptGraph();
			if (!fe_nw00())
			{
				setChangeLock(TRUE);
				clearMessage();
				clearFaceName();
				putFaceWindow(FALSE);
				putMessageWindow(FALSE);
				setChangeLock(FALSE);
				g_cancel_num = 4;
				g_schedule_cancel = TRUE;
				return;
			}
			setParamGraph();
			fe00();
			while (getDay() < 30)
			{
				NextDay();
				putDateWindow(TRUE);
				if (getOptionMessage() == 0)
					waitOnly(5);
				else
					waitOnly(12);
			}
			e_birth();			//a
			NextDay();
			putDateWindow(TRUE);
			waitChangeGraph();
			setChangeLock(TRUE);
			clearMessage();
			clearFaceName();
			putFaceWindow(FALSE);
			putMessageWindow(FALSE);
			putDateWindow(FALSE);
			setChaNum(0, cDA0);
			setBgNum(BG_bgr000);
			setChangeLock(FALSE);
			g_cancel_num = 3;
			g_schedule_cancel = TRUE;
			waitChangeGraph();
			playRoomBGM();
			return;
		}
	}

	if (getYear() == 1448 && getMonth() == 3 && getDay() == 31)
	{
		startEnding();
		g_ending_flag = TRUE;
		return;
	}

// ͉\ȃXPW[ݒ肷
	if (getcon() == conS)
	{
		// ×{ȊO֎~
		for (i=0; i<23; i++)
			setScheduleTip(i, 0);
		setScheduleTip(23, 1);
		g_schedule_tag = 2;
	} else {
		for (i=0; i<21; i++)
			setScheduleTip(i, getSchSet(i));
		setScheduleTip(22, getSchSet(22));
		setScheduleTip(23, 0);
		g_schedule_tag = 0;
		// oJX`FbN
		if ((s32)getGold() - getLivingGold() + getScheduleGold(jBakansu) < 0)
		{
			setScript(_ROOM_PSC, ROOM_SETSELECTSCHBUF);
			waitScript();
			setScheduleTip(jBakansu, 0);
		} else {
			setScheduleTip(jBakansu, 1);
		}
	}

	newScheduleGuide();


	g_schedule_day_put = FALSE;
	g_schedule_phase = 0;		// {

	setSkipFlag(FALSE);
	setScheduleGraph(g_schedule_tag);
	putScheduleCalendar(TRUE);
}


//--------------------------------------
// XPW[s
//--------------------------------------
void initSchedule(void)
{
	initMapSelect();
	setScriptThread(schedule_exec);
//	g_step = SCHEDULE_MODE_SET_WAIT;
}
//--------------------------------------
BOOL mainSchedule(void)
{
	BOOL result;

	result = isEndScriptThread();

	//execScript();
	execMapSelect();
	//execEventGraph();

	return !result;
}




//--------------------------------------
// XPW[sXNvg
//--------------------------------------
static void schedule_exec(void)
{
	int i;
	u8 y, m, d, w;

	switch (getPolicy())
	{
		case polNor:
			setScript(_ROOM_PSC, ROOM_ROOM_SCHEXEC_POLNOR);
			break;
		case polAct:
			setScript(_ROOM_PSC, ROOM_ROOM_SCHEXEC_POLACT);
			break;
		case polMod:
			setScript(_ROOM_PSC, ROOM_ROOM_SCHEXEC_POLMOD);
			break;
		case polDie:
			setScript(_ROOM_PSC, ROOM_ROOM_SCHEXEC_POLDIE);
			break;
		default:
			;
	}
	waitScript();
	setAddGold(-getLivingGold());
	setParamWindowObj();
	//waitChangeGold();

	g_schedule_phase = 0;

	setRankupMsg(0, OFF);
	setRankupMsg(1, OFF);
	setRankupMsg(2, ON);
	if (g_schedule[0] != g_schedule[1])
		setRankupMsg(1, ON);
	if (g_schedule[0] != g_schedule[1] && g_schedule[0] != g_schedule[2])
		setRankupMsg(0, ON);
	for (i=0; i<24; i++)
		setSchLastRes(i, 0);
	for (i=0; i<3; i++)
		setSchLast(i, 0);

	while (g_schedule_phase < 3)
	{
		g_schedule_run_no = g_schedule[g_schedule_phase];
		g_schedule_run_days = 10;
		if (g_schedule_phase == 2)
		{
			u8 y, m, d, w;
			getDays(&y, &m, &d, &w);
			g_schedule_run_days = (u8)(getMaxday(m) - 20);
		}

		funcSetAddParamValue();
		if (g_schedule_run_no != jOdekake)
			funcSetParamUpdateList();

		g_schedule_tmp_day = 0;
		g_schedule_good = 0;
		g_schedule_tmp_end = 0;
		g_schedule_NEM = FALSE;

		switch (g_schedule_run_no)
		{
			case jZagaku:
			case jBujyutu:
			case jMajyutu:
			case jReihou:
			case jGeijyutu:
			case jButou:
				setChangeLock(TRUE);
				clearCha(3);
				setBgNum(BG_map01);
				setChangeLock(FALSE);
				waitChangeGraph();
				if (getSchRank(g_schedule_run_no) == 3)
					schExecAl();
				else
					schExecSt();
				break;
			case jKajiTetudai:
			case jKomori:
			case jNoujyou:
			case jKyoukai:
			case jRyouriya:
			case jMeido:
			case jKikori:
			case jYadoya:
			case jIchiba:
			case jSakaba:
			case jKateiKyousi:
			case jMeidoSakaba:
			case jAyasiiSakaba:
			case jKajino:
				setChangeLock(TRUE);
				clearCha(3);
				setBgNum(BG_map01);
				setChangeLock(FALSE);
				waitChangeGraph();
				schExecAl();
				break;
			case jYasumi:
				schYasumi();
				break;
			case jBakansu:
				schBakansu();
				break;
			case jOdekake:
				schOdekake();
				break;
			case jRyouyou:
				schRyouyou();
				break;
		}
		//----------
		for (i=0; i<28; i++)
			setParamName(i, FALSE);
		setParamWindowObj();
		setParamNameObj();
		// P^[̓Ƃɖ߂Ă
		incSchCount(g_schedule_run_no);

		// 2006 Insert ---->
		// KɂACo̐Ml
		switch (g_schedule_run_no)
		{
			case jBujyutu:
				addParam(pR1, 100);		// [[
				break;
			case jButou:
				addParam(pR2, 100);		// NX`[i
				break;
			case jGeijyutu:
				addParam(pR3, 100);		// }[
				break;
			default:
				;
		}
		// <---- (2006 Insert)

		waitChangeGraph();
		waitChangeGold();

		g_schedule_phase++;
		if (g_schedule_phase < 3)
		{
			decEv32();
			getDays(&y, &m, &d, &w);
			if (g_schedule_phase == 1 && m == 1)
				e_nfd();		//
			decBirth();
			e_birth();			//a
			cmdIncDay();
			setChangeLock(TRUE);
			clearScheduleAnim();
			putDateWindow(TRUE);
			setChangeLock(FALSE);
			waitChangeGraph();
		}
	}
	//----------
	// R^[I
	setChangeLock(TRUE);
	getDays(&y, &m, &d, &w);
	if (getGameM() == y1448_3)
	{
		// ŏÎ͂
		decBirth();
		e_birth();		//a
		putDateWindow(FALSE);	//	#cmd{ cmdCalendarClose }
	} else
	if (m != 12)
	{
		decEv32();
		decBirth();
		e_birth();		//a

		putDateWindow(FALSE);	//	#cmd{ cmdCalendarClose }
		cmdIncDay();
	} else {
		// PQRP̂͂
		decEv32();
		decBirth();
		e_birth();		//a
		e_holi();		//a
		//	#w{ 10 }
		cmdIncDay();
	}
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	clearScheduleAnim();
	setChangeLock(FALSE);
	waitChangeGraph();
	waitChangeGold();
}

//--------------------------------------------------
static void decEv32(void)
{
	if (getLabel(LF_ev085) == ON && getLabel(LF_ev032) == OFF)
	{
		putDateWindow(FALSE);
		setScript(_EV032_PSC, EV032_EV032);
		waitScript();
		putDateWindow(TRUE);
	}
}


//------------------------------------------------------
// p[^Zlobt@NA
//------------------------------------------------------
static void funcClearAddParamValue(void)
{
	int i;

	for (i=0; i<28; i++)
	{
		g_param_add_value[i] = 0;
		g_param_add_width[i] = 0;
	}
}
//------------------------------------------------------
// XPW[ԍɂAs̋zobt@Zbg
//------------------------------------------------------
static void funcSetFailureGold(void)
{
	if (g_schedule_run_no == jZagaku || g_schedule_run_no == jBujyutu || g_schedule_run_no == jGeijyutu)
	{
		switch (getSchRank(g_schedule_run_no))
		{
			case 0:		// 
				g_gold_add_value = -10;
				break;
			case 1:		// 
				g_gold_add_value = -15;
				break;
			case 2:		// ㋉
				g_gold_add_value = -30;
				break;
			case 3:		// }X^[
				g_gold_add_value = 0;
				break;
		}
	} else
	if (g_schedule_run_no == jMajyutu || g_schedule_run_no == jButou)
	{
		switch (getSchRank(g_schedule_run_no))
		{
			case 0:		// 
				g_gold_add_value = -15;
				break;
			case 1:		// 
				g_gold_add_value = -20;
				break;
			case 2:		// ㋉
				g_gold_add_value = -35;
				break;
			case 3:		// }X^[
				g_gold_add_value = 0;
				break;
		}
	} else
	if (g_schedule_run_no == jReihou)
	{
		switch (getSchRank(g_schedule_run_no))
		{
			case 0:		// 
				g_gold_add_value = -10;
				break;
			case 1:		// 
				g_gold_add_value = -15;
				break;
			case 2:		// ㋉
				g_gold_add_value = -35;
				break;
			case 3:		// }X^[
				g_gold_add_value = 0;
				break;
		}
	} else
		g_gold_add_value = 0;
}

//------------------------------------------------------
static void funcParamAddUpdate(void)
{
	int i;
	s32 value, old_value, new_value;
	BOOL update_win;

	update_win = FALSE;
	setAddGold(g_gold_add_value);
	if (g_gold_add_value != 0)
		update_win = TRUE;
	for (i=0; i<28; i++)
	{
		value = g_param_add_value[i];
		if (g_param_add_width[i] != 0)
			value += getRandom() % (g_param_add_width[i]+1);
		old_value = (s32)getParam(i);
		addParam(i, value);
		new_value = (s32)getParam(i);
		if (new_value == old_value)
			setParamColor(i, 0);
		else
		if (i != pHIROU)
		{
			if (value > 0)
				setParamColor(i, 1);
			else
				setParamColor(i, 2);
			if (i == pHeight || i == pWeight || i == pBust || i == pWaist || i == pHip)
				update_win = TRUE;
		} else {
			if (value > 0)
				setParamColor(i, 2);
			else
				setParamColor(i, 1);
		}
	}
	if (update_win)
		setParamWindowObj();
	setParamObj();
	for (i=0; i<28; i++)
		setParamColor(i, 0);
}

//------------------------------------------------------
// p[^ZlP^Qɂ
// iΏۃp[^̗͑́`Ƃ܂łƂj
//------------------------------------------------------
static void funcHalfParamAddValue(void)
{
	int i;

	for (i=0; i<=pINGOU; i++)
	{
		g_param_add_value[i] /= 2;
		g_param_add_width[i] /= 2;
	}
}

//------------------------------------------------------
// XPW[ԍɂAp[^Zlobt@Zbg
//------------------------------------------------------
static void funcSetAddParamValue(void)
{
	int i;

	g_gold_add_value = getScheduleGold(g_schedule_run_no);
	funcClearAddParamValue();

	switch (g_schedule_run_no)
	{
		case jZagaku:						// w
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:						// wF
					g_param_add_value[pTAIRYOKU] =  -50;
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pMIRYOKU]  =  -10;
					g_param_add_value[pMORAL]    =  100;
					g_param_add_value[pKANNJYU]  = -100;
					g_param_add_value[pHIROU]    =  100;
					break;
				case 1:						// wF
					g_param_add_value[pTAIRYOKU] =  -50;
					g_param_add_value[pCHIRYOKU] =  250;
					g_param_add_value[pMIRYOKU]  =  -20;
					g_param_add_value[pMORAL]    =  180;
					g_param_add_value[pKANNJYU]  = -100;
					g_param_add_value[pKIDATE]   =  200;
					g_param_add_value[pHIROU]    =  150;
					break;
				case 2:						// wF㋉
					g_param_add_value[pTAIRYOKU] =  -50;
					g_param_add_value[pCHIRYOKU] =  200;
					g_param_add_value[pMIRYOKU]  =  -30;
					g_param_add_value[pPRIDE]    =  150;
					g_param_add_value[pMORAL]    =  100;
					g_param_add_value[pKANNJYU]  = -100;
					g_param_add_value[pHIROU]    =  200;
					break;
				case 3:						// wF}X^[
					g_param_add_value[pTAIRYOKU] =  -50;
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pMIRYOKU]  =  -20;
					g_param_add_value[pPRIDE]    =  100;
					g_param_add_value[pMORAL]    =   50;
					g_param_add_value[pKANNJYU]  = -100;
					g_param_add_value[pHIROU]    =  200;
					break;
			}
			break;
		case jBujyutu:						// p
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:						// pF
					g_param_add_value[pTAIRYOKU] =  150;
					g_param_add_value[pCHIRYOKU] =  -20;
					g_param_add_value[pMIRYOKU]  =  -10;
					g_param_add_value[pKIHINN]   =  -30;
					g_param_add_value[pKANNJYU]  =  -20;
					g_param_add_value[pBUJYUTU]  =  100;
					g_param_add_value[pHIROU]    =  125;
					break;
				case 1:						// pF
					g_param_add_value[pTAIRYOKU] =  150;
					g_param_add_value[pCHIRYOKU] =  -20;
					g_param_add_value[pMIRYOKU]  =  -20;
					g_param_add_value[pKIHINN]   =  -10;
					g_param_add_value[pKANNJYU]  =  -10;
					g_param_add_value[pBUJYUTU]  =  220;
					g_param_add_value[pHIROU]    =  200;
					break;
				case 2:						// pF㋉
					g_param_add_value[pTAIRYOKU] =  150;
					g_param_add_value[pCHIRYOKU] =  -20;
					g_param_add_value[pMIRYOKU]  =  -20;
					g_param_add_value[pPRIDE]    =   50;
					g_param_add_value[pKIHINN]   =   10;
					g_param_add_value[pKANNJYU]  =  -30;
					g_param_add_value[pBUJYUTU]  =  250;
					g_param_add_value[pHIROU]    =  250;
					break;
				case 3:						// pF}X^[
					g_param_add_value[pTAIRYOKU] =  150;
					g_param_add_value[pMIRYOKU]  =  -20;
					g_param_add_value[pPRIDE]    =  100;
					g_param_add_value[pKIHINN]   =   10;
					g_param_add_value[pKANNJYU]  =  -30;
					g_param_add_value[pBUJYUTU]  =  200;
					g_param_add_value[pHIROU]    =  225;
					break;
			}
			break;

		case jMajyutu:					// p
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:					// pF
					g_param_add_value[pCHIRYOKU] =  100;
					g_param_add_value[pMAJYUTU]  =  100;
					g_param_add_value[pHIROU]    =  100;
					break;
				case 1:					// pF
					g_param_add_value[pTAIRYOKU] =  100;
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pKIHINN]   =  -10;
					g_param_add_value[pKANNJYU]  =  -10;
					g_param_add_value[pMAJYUTU]  =  200;
					g_param_add_value[pHIROU]    =  200;
					break;
				case 2:					// pF㋉
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pPRIDE]    =  100;
					g_param_add_value[pMORAL]    =  -50;
					g_param_add_value[pMAJYUTU]  =  250;
					g_param_add_value[pHIROU]    =  200;
					g_param_add_value[pINGOU]    =   75;
					break;
				case 3:					// pF}X^[
					g_param_add_value[pCHIRYOKU] =  125;
					g_param_add_value[pPRIDE]    =   50;
					g_param_add_value[pMORAL]    =  -50;
					g_param_add_value[pMAJYUTU]  =  200;
					g_param_add_value[pHIROU]    =  175;
					g_param_add_value[pINGOU]    =  100;
					break;
			}
			break;

		case jReihou:					// @
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:					// @F
					g_param_add_value[pTAIRYOKU] =  -10;
					g_param_add_value[pMIRYOKU]  =   30;
					g_param_add_value[pPRIDE]    =   50;
					g_param_add_value[pMORAL]    =  100;
					g_param_add_value[pKIHINN]   =  120;
					g_param_add_value[pKANNJYU]  =  -20;
					g_param_add_value[pKIDATE]   =  100;
					g_param_add_value[pHIROU]    =  100;
					break;
				case 1:					// @F
					g_param_add_value[pTAIRYOKU] =  -25;
					g_param_add_value[pMIRYOKU]  =   40;
					g_param_add_value[pPRIDE]    =  150;
					g_param_add_value[pMORAL]    =  200;
					g_param_add_value[pKIHINN]   =  150;
					g_param_add_value[pKANNJYU]  =  -10;
					g_param_add_value[pKIDATE]   =  100;
					g_param_add_value[pHIROU]    =  150;
					g_param_add_value[pINGOU]    = -100;
					break;
				case 2:					// @F㋉
					g_param_add_value[pTAIRYOKU] =  -50;
					g_param_add_value[pMIRYOKU]  =   50;
					g_param_add_value[pPRIDE]    =  200;
					g_param_add_value[pMORAL]    =  150;
					g_param_add_value[pKIHINN]   =  250;
					g_param_add_value[pKANNJYU]  =  -50;
					g_param_add_value[pKIDATE]   =  100;
					g_param_add_value[pHIROU]    =  200;
					g_param_add_value[pINGOU]    = -100;
					break;
				case 3:					// @F}X^[
					g_param_add_value[pMIRYOKU]  =   30;
					g_param_add_value[pPRIDE]    =  150;
					g_param_add_value[pMORAL]    =   50;
					g_param_add_value[pKIHINN]   =  200;
					g_param_add_value[pKANNJYU]  =  -10;
					g_param_add_value[pKIDATE]   =  200;
					g_param_add_value[pHIROU]    =  200;
					g_param_add_value[pINGOU]    =  -50;
					break;
			}
			break;

		case jGeijyutu:					// |p
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:					// |pF
					g_param_add_value[pTAIRYOKU] =  -30;
					g_param_add_value[pKIHINN]   =  -10;
					g_param_add_value[pKANNJYU]  =  210;
					g_param_add_value[pHIROU]    =  100;
					break;
				case 1:					// |pF
					g_param_add_value[pTAIRYOKU] =  -30;
					g_param_add_value[pCHIRYOKU] =  100;
					g_param_add_value[pMORAL]    =  -50;
					g_param_add_value[pKIHINN]   =  -20;
					g_param_add_value[pKANNJYU]  =  200;
					g_param_add_value[pHIROU]    =  150;
					break;
				case 2:					// |pF㋉
					g_param_add_value[pTAIRYOKU] =  -30;
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pMORAL]    =  -50;
					g_param_add_value[pKIHINN]   =  -30;
					g_param_add_value[pKANNJYU]  =  250;
					g_param_add_value[pHIROU]    =  200;
					break;
				case 3:					// |pF}X^[
					g_param_add_value[pTAIRYOKU] =  -30;
					g_param_add_value[pCHIRYOKU] =  150;
					g_param_add_value[pKIHINN]   =  -20;
					g_param_add_value[pKANNJYU]  =  200;
					g_param_add_value[pHIROU]    =  200;
					break;
			}
			break;

		case jButou:					// 
			switch (getSchRank(g_schedule_run_no))
			{
				case 0:					// F
					g_param_add_value[pTAIRYOKU] =   50;
					g_param_add_value[pCHIRYOKU] =  -50;
					g_param_add_value[pMIRYOKU]  =  150;
					g_param_add_value[pKIHINN]   =  100;
					g_param_add_value[pKANNJYU]  =   50;
					g_param_add_value[pHIROU]    =  125;
					break;
				case 1:					// F
					g_param_add_value[pTAIRYOKU] =   75;
					g_param_add_value[pCHIRYOKU] =  -50;
					g_param_add_value[pMIRYOKU]  =  200;
					g_param_add_value[pPRIDE]    =  100;
					g_param_add_value[pKIHINN]   =  150;
					g_param_add_value[pKANNJYU]  =  100;
					g_param_add_value[pHIROU]    =  175;
					break;
				case 2:					// F㋉
					g_param_add_value[pTAIRYOKU] =  100;
					g_param_add_value[pCHIRYOKU] =  -50;
					g_param_add_value[pMIRYOKU]  =  250;
					g_param_add_value[pPRIDE]    =  150;
					g_param_add_value[pKIHINN]   =  200;
					g_param_add_value[pKANNJYU]  =  150;
					g_param_add_value[pHIROU]    =  250;
					break;
				case 3:					// F}X^[
					g_param_add_value[pTAIRYOKU] =   50;
					g_param_add_value[pCHIRYOKU] =  -50;
					g_param_add_value[pMIRYOKU]  =  100;
					g_param_add_value[pPRIDE]    =  100;
					g_param_add_value[pKIHINN]   =  150;
					g_param_add_value[pKANNJYU]  =  100;
					g_param_add_value[pHIROU]    =  250;
					break;
			}
			break;

		case jKajiTetudai:				// Ǝ`
			g_param_add_value[pKIDATE]   =   25;
			g_param_add_value[pHIROU]    =   50;
			g_param_add_value[pCU]       =   50;
			g_param_add_width[pTAIRYOKU] =   50;
			g_param_add_width[pMORAL]    =   80;
			g_param_add_width[pKANNJYU]  =   30;
			g_param_add_width[pKIDATE]   =  100;
			g_param_add_width[pCHIMEI]   =   50;
			g_param_add_width[pHIROU]    =   50;
			g_param_add_width[pCU]       =   50;
			break;

		case jKomori:					// q
			g_param_add_value[pMIRYOKU]  =  -40;
			g_param_add_value[pPRIDE]    =  -20;
			g_param_add_value[pKIHINN]   =  -50;
			g_param_add_value[pKIDATE]   =   25;
			g_param_add_value[pHIROU]    =   70;
			g_param_add_width[pTAIRYOKU] =   70;
			g_param_add_width[pMIRYOKU]  =   30;
			g_param_add_width[pPRIDE]    =   20;
			g_param_add_width[pKIHINN]   =   50;
			g_param_add_width[pKANNJYU]  =   30;
			g_param_add_width[pKIDATE]   =  125;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jNoujyou:					// _
			g_param_add_value[pCHIRYOKU] =  -20;
			g_param_add_value[pMIRYOKU]  =  -60;
			g_param_add_value[pKIHINN]   =  -50;
			g_param_add_value[pKANNJYU]  =  -30;
			g_param_add_value[pHIROU]    =  200;
			g_param_add_width[pTAIRYOKU] =  150;
			g_param_add_width[pCHIRYOKU] =   20;
			g_param_add_width[pMIRYOKU]  =   40;
			g_param_add_width[pKIHINN]   =   50;
			g_param_add_width[pKANNJYU]  =   30;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jKyoukai:					// 
			g_param_add_value[pMIRYOKU]  = -120;
			g_param_add_value[pPRIDE]    =   25;
			g_param_add_value[pMORAL]    =   75;
			g_param_add_value[pKANNJYU]  =  -20;
			g_param_add_value[pHIROU]    =   50;
			g_param_add_value[pINGOU]    = -100;
			g_param_add_value[pMAZOKU]   = -100;
			g_param_add_width[pMIRYOKU]  =  110;
			g_param_add_width[pPRIDE]    =   75;
			g_param_add_width[pMORAL]    =   50;
			g_param_add_width[pKANNJYU]  =   20;
			g_param_add_width[pHIROU]    =   50;
			g_param_add_width[pINGOU]    =   90;
			g_param_add_width[pMAZOKU]   =   50;
			break;

		case jRyouriya:					// 
			g_param_add_value[pCHIRYOKU] =  -20;
			g_param_add_value[pMIRYOKU]  =  -70;
			g_param_add_value[pKIHINN]   =  -20;
			g_param_add_value[pHIROU]    =  200;
			g_param_add_width[pCHIRYOKU] =   20;
			g_param_add_width[pMIRYOKU]  =   70;
			g_param_add_width[pPRIDE]    =  100;
			g_param_add_width[pKIHINN]   =   20;
			g_param_add_width[pKANNJYU]  =   50;
			g_param_add_width[pKIDATE]   =   60;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jMeido:					// Ch
			g_param_add_value[pMORAL]    =   50;
			g_param_add_value[pKIHINN]   =   50;
			g_param_add_value[pHIROU]    =  200;
			g_param_add_width[pMIRYOKU]  =  100;
			g_param_add_width[pMORAL]    =   50;
			g_param_add_width[pKIHINN]   =   20;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jKikori:					// ؂
			g_param_add_value[pTAIRYOKU] =  100;
			g_param_add_value[pCHIRYOKU] =  -30;
			g_param_add_value[pMIRYOKU]  =  -70;
			g_param_add_value[pKIHINN]   = -150;
			g_param_add_value[pKANNJYU]  =  -50;
			g_param_add_value[pHIROU]    =  400;
			g_param_add_width[pTAIRYOKU] =  200;
			g_param_add_width[pCHIRYOKU] =   30;
			g_param_add_width[pMIRYOKU]  =   70;
			g_param_add_width[pPRIDE]    =   10;
			g_param_add_width[pKIHINN]   =   50;
			g_param_add_width[pKANNJYU]  =   50;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jYadoya:					// h
			g_param_add_value[pTAIRYOKU] =   50;
			g_param_add_value[pCHIRYOKU] =  -20;
			g_param_add_value[pMIRYOKU]  =  -60;
			g_param_add_value[pKIHINN]   =  -50;
			g_param_add_value[pKANNJYU]  =  -50;
			g_param_add_value[pHIROU]    =  150;
			g_param_add_width[pTAIRYOKU] =   50;
			g_param_add_width[pCHIRYOKU] =   20;
			g_param_add_width[pMIRYOKU]  =   40;
			g_param_add_width[pMORAL]    =   50;
			g_param_add_width[pKIHINN]   =   50;
			g_param_add_width[pKANNJYU]  =   50;
			g_param_add_width[pKIDATE]   =   50;
			g_param_add_width[pHIROU]    =  150;
			break;

		case jIchiba:					// s
			g_param_add_value[pKIHINN]   =  -30;
			g_param_add_value[pKANNJYU]  =  -30;
			g_param_add_value[pHIROU]    =  150;
			g_param_add_width[pCHIRYOKU] =  100;
			g_param_add_width[pKIHINN]   =   30;
			g_param_add_width[pKANNJYU]  =   30;
			g_param_add_width[pKIDATE]   =  100;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jSakaba:					// 
			g_param_add_value[pCHIRYOKU] =  -30;
			g_param_add_value[pMIRYOKU]  =   50;
			g_param_add_value[pMORAL]    =  -50;
			g_param_add_value[pKIHINN]   =  -20;
			g_param_add_value[pKANNJYU]  =  -10;
			g_param_add_value[pHIROU]    =  200;
			g_param_add_width[pCHIRYOKU] =   30;
			g_param_add_width[pMIRYOKU]  =   50;
			g_param_add_width[pMORAL]    =   50;
			g_param_add_width[pKIHINN]   =   20;
			g_param_add_width[pKANNJYU]  =   10;
			g_param_add_width[pKIDATE]   =   50;
			g_param_add_width[pHIROU]    =  150;
			break;

		case jKateiKyousi:				// ƒ닳t
			g_param_add_value[pTAIRYOKU] = -130;
			g_param_add_value[pCHIRYOKU] =   20;
			g_param_add_value[pKANNJYU]  =  -70;
			g_param_add_value[pHIROU]    =  200;
			g_param_add_width[pTAIRYOKU] =   80;
			g_param_add_width[pCHIRYOKU] =   80;
			g_param_add_width[pMORAL]    =   50;
			g_param_add_width[pKANNJYU]  =   60;
			g_param_add_width[pHIROU]    =  100;
			break;

		case jMeidoSakaba:				// Ch
			g_param_add_value[pTAIRYOKU] =  -30;
			g_param_add_value[pCHIRYOKU] =  -90;
			g_param_add_value[pMIRYOKU]  =  100;
			g_param_add_value[pPRIDE]    = -120;
			g_param_add_value[pMORAL]    = -150;
			g_param_add_value[pKANNJYU]  =   20;
			g_param_add_value[pHIROU]    =  350;
			g_param_add_value[pINGOU]    =   50;
			g_param_add_width[pTAIRYOKU] =   30;
			g_param_add_width[pCHIRYOKU] =   90;
			g_param_add_width[pMIRYOKU]  =  100;
			g_param_add_width[pPRIDE]    =   70;
			g_param_add_width[pMORAL]    =   80;
			g_param_add_width[pKANNJYU]  =   30;
			g_param_add_width[pCHIMEI]   =  100;
			g_param_add_width[pHIROU]    =  200;
			g_param_add_width[pINGOU]    =   50;
			break;

		case jAyasiiSakaba:				// 
			g_param_add_value[pCHIRYOKU] = -100;
			g_param_add_value[pMIRYOKU]  =  200;
			g_param_add_value[pPRIDE]    = -150;
			g_param_add_value[pMORAL]    = -170;
			g_param_add_value[pKANNJYU]  =  -50;
			g_param_add_value[pHIROU]    =  550;
			g_param_add_value[pFA]       = -500;
			g_param_add_value[pINGOU]    =  100;
			g_param_add_width[pCHIRYOKU] =  100;
			g_param_add_width[pMIRYOKU]  =  100;
			g_param_add_width[pPRIDE]    =   80;
			g_param_add_width[pMORAL]    =  120;
			g_param_add_width[pKANNJYU]  =   50;
			g_param_add_width[pKIDATE]   =   40;
			g_param_add_width[pCHIMEI]   =   50;
			g_param_add_width[pHIROU]    =  150;
			g_param_add_width[pFA]       =  500;
			g_param_add_width[pINGOU]    =  200;
			break;

		case jKajino:					// JWm
			g_param_add_value[pCHIRYOKU] =   20;
			g_param_add_value[pMIRYOKU]  =   70;
			g_param_add_value[pPRIDE]    = -100;
			g_param_add_value[pMORAL]    = -150;
			g_param_add_value[pKANNJYU]  =  -20;
			g_param_add_value[pHIROU]    =  450;
			g_param_add_value[pFA]       = -300;
			g_param_add_value[pINGOU]    =   50;
			g_param_add_width[pCHIRYOKU] =   80;
			g_param_add_width[pMIRYOKU]  =  130;
			g_param_add_width[pPRIDE]    =   50;
			g_param_add_width[pMORAL]    =  100;
			g_param_add_width[pKIHINN]   =   40;
			g_param_add_width[pKANNJYU]  =   20;
			g_param_add_width[pHIROU]    =  150;
			g_param_add_width[pFA]       =  300;
			g_param_add_width[pINGOU]    =  100;
			break;

		case jYasumi:					
			// ɑI݂邽߁Aŕ\LȂ
			// Kȉ̃Tu[`gp
			// funcSetAddParamValueYasumi_0
			// funcSetAddParamValueYasumi_1
			break;

		case jBakansu:
			g_param_add_value[pHIROU] = -1000 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
			g_param_add_value[pFA] = 100;
			g_param_add_width[pFA] = 100;
			break;

		case jOdekake:					//PtF[Y
			g_param_add_value[pTAIRYOKU] =  300;
			for (i=0; i<3; i++)
				g_param_add_value[getRandom()%12] += 100;
			g_param_add_value[pHIROU] = -2000 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
			break;

		case jRyouyou:
			break;
	}
}


//--------------------------------------------------
// XPW[s̋ʁidj
//--------------------------------------------------
static void schExecAl(void)
{
	u8 y, m, d, w;

	setBGM(SEQ_PRM4_21);
	playBGM();

	schStartScr();

	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(TRUE);
	setChangeLock(FALSE);
	waitChangeGraph();

	while (g_schedule_run_days > 0)
	{
		funcSetAddParamValue();			// Zobt@̃Zbg
		GetSchSucessParsent();			// 擾

		getDays(&y, &m, &d, &w);
		if (w == 0)
		{
			setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT3);
			funcClearAddParamValue();
			g_gold_add_value = 0;
		} else {
			g_schedule_tmp_day++;
			if (getcon() == conY && getRandom() % 2 == 1)
			{
				putScheduleAnim(g_schedule_run_no, 2);
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT2);
				funcClearAddParamValue();
				g_param_add_value[pHIROU] = -200;
				funcSetFailureGold();
			} else
			if (getRandom() % 100 < g_schedule_suc_per)
			{
				putScheduleAnim(g_schedule_run_no, 0);
				incSchSuc(g_schedule_run_no);
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT7);
				g_schedule_good++;
			} else {
				putScheduleAnim(g_schedule_run_no, 1);
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT6);
				funcSetFailureGold();
				funcHalfParamAddValue();		// ㏸1/2
			}
		}
		funcParamAddUpdate();
		waitScript();

		g_schedule_run_days--; 
		incSchDays(g_schedule_run_no);

		if (g_schedule_run_days > 0)
		{
			NextDay();
			putDateWindow(TRUE);
			//waitChangeGraph();
		}
	}
	if (g_schedule_tmp_day == g_schedule_good)
	{
		//S
		g_schedule_tmp_end = 2;
	} else
	if (g_schedule_good == 0)
	{
		//Ss
		g_schedule_tmp_end = 0;
	} else {
		g_schedule_tmp_end = 1;
	}
	schEndScr();
	setSchLast(g_schedule_phase, (u8)(g_schedule_run_no+1));
}


//--------------------------------------------------
// XPW[s̋ʁi׋j
//--------------------------------------------------
static void schExecSt(void)
{
	u8 y, m, d, w;

	setBGM(SEQ_PRM4_21);
	playBGM();

	schStartScr();

	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(TRUE);
	setChangeLock(FALSE);
	// Aj̏
	waitChangeGraph();

	while (g_schedule_run_days > 0)
	{
		funcSetAddParamValue();			// Zobt@̃Zbg
		GetSchSucessParsent();			// 擾

		getDays(&y, &m, &d, &w);
		if (w == 0)
		{
			// j
			setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT3);
			funcClearAddParamValue();
			g_gold_add_value = 0;
		} else {
			g_schedule_tmp_day++;
			if (((s32)getGold() + g_gold_add_value) < 0)
			{
				// Ȃ
				putScheduleAnim(g_schedule_run_no, 2);
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT4);
				funcClearAddParamValue();
				g_param_add_value[pHIROU] = -200;
				g_schedule_NEM = TRUE;	//ȂtOON
			} else {
				if (getcon() == conY && getRandom() % 2 == 1)
				{
					// T{
					putScheduleAnim(g_schedule_run_no, 2);
					setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT2);
					funcClearAddParamValue();
					funcSetFailureGold();
				} else {
					if (getRandom() % 100 < g_schedule_suc_per)
					{
						// 
						putScheduleAnim(g_schedule_run_no, 0);
						incSchSuc(g_schedule_run_no);
						setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT0);
						g_schedule_good++;
					} else {
						// s
						putScheduleAnim(g_schedule_run_no, 1);
						setScript(_SCHEDULE_PSC, SCHEDULE_SCHTEXT1);
						funcSetFailureGold();
						funcHalfParamAddValue();		// ㏸1/2
					}
				}
			}
		}
		funcParamAddUpdate();
		waitScript();

		g_schedule_run_days--;
		incSchDays(g_schedule_run_no);

		if (g_schedule_run_days > 0)
		{
			NextDay();
			putDateWindow(TRUE);
			//waitChangeGraph();
		}
	}
	if (g_schedule_NEM)
	{
		g_schedule_tmp_end = 3;			//s
	} else
	if (g_schedule_tmp_day == g_schedule_good)
	{
		//S
		g_schedule_tmp_end = 2;
		incSchLastRes(g_schedule_run_no);
	} else
	if (g_schedule_good  == 0)
	{
		//Ss
		g_schedule_tmp_end = 0;
		decSchLastRes(g_schedule_run_no);
	} else {
		g_schedule_tmp_end = 1;
	}
	schEndScr();
	setSchLast(g_schedule_phase, (u8)(g_schedule_run_no+1));
}


//--------------------------------------------------
// tr00Ƃal00ƂĂԃ[`
//--------------------------------------------------
static void schStartScr(void)
{
	switch (g_schedule_run_no)
	{
		case jZagaku:					// w
			tr00(g_schedule_run_no);
			break;
		case jBujyutu:					// p
			tr01(g_schedule_run_no);
			break;
		case jMajyutu:					// p
			tr02(g_schedule_run_no);
			break;
		case jReihou:					// @
			tr03(g_schedule_run_no);
			break;
		case jGeijyutu:					// |p
			tr04(g_schedule_run_no);
			break;
		case jButou:					// 
			tr05(g_schedule_run_no);
			break;
		case jKajiTetudai:				// Ǝ`
			al00();
			break;
		case jKomori:					// q
			al01();
			break;
		case jNoujyou:					// _
			al02();
			break;
		case jKyoukai:					// 
			al03();
			break;
		case jRyouriya:					// 
			al04();
			break;
		case jMeido:					// Ch
			al05();
			break;
		case jKikori:					// ؂
			al06();
			break;
		case jYadoya:					// h
			al07();
			break;
		case jIchiba:					// s
			al08();
			break;
		case jSakaba:					// 
			al09();
			break;
		case jKateiKyousi:				// ƒ닳t
			al10();
			break;
		case jMeidoSakaba:				// Ch
			al11();
			break;
		case jAyasiiSakaba:				// 
			al12();
			break;
		case jKajino:					// JWm
			al13();
			break;
		case jYasumi:					
			break;
		case jBakansu:
			break;
		case jOdekake:					//PtF[Y
			break;
		case jRyouyou:
			break;
	}
}

//--------------------------------------------------
// tr00_endƂal00_endƂĂԃ[`
//--------------------------------------------------
static void schEndScr(void)
{
	int i;

	for (i=0; i<28; i++)
		setParamName(i, FALSE);
	setParamNameObj();
	clearScheduleAnim();
	switch (g_schedule_run_no)
	{
		case jZagaku:					// w
			tr00_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			break;
		case jBujyutu:					// p
			tr01_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			break;
		case jMajyutu:					// p
			tr02_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			break;
		case jReihou:					// @
			tr03_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			break;
		case jGeijyutu:					// |p
			tr04_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			//GZbg
			if (isItem(13) != -1)
				setParamUp(pKANNJYU, 50 * g_schedule_good);
			//`̍H
			if (isItem(77) != -1)
				setParamUp(pKANNJYU, 75 * g_schedule_good);
			break;
		case jButou:					// 
			tr05_end(g_schedule_run_no, g_schedule_tmp_end, g_schedule_phase);
			//_XV[Y
			if (isItem(14) != -1)
			{
				funcClearAddParamValue();
				g_param_add_value[pMIRYOKU] = 50 * g_schedule_good;
				g_param_add_value[pKIHINN] = 50 * g_schedule_good;
				funcSetParamUpdateList();
				funcParamAddUpdate();
			}
			//KX̌C
			if (isItem(78) != -1)
			{
				funcClearAddParamValue();
				g_param_add_value[pMIRYOKU] = 75 * g_schedule_good;
				g_param_add_value[pKIHINN] = 75 * g_schedule_good;
				funcSetParamUpdateList();
				funcParamAddUpdate();
			}
			break;
		case jKajiTetudai:				// Ǝ`
			al00_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jKomori:					// q
			al01_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jNoujyou:					// _
			al02_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jKyoukai:					// 
			al03_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jRyouriya:					// 
			al04_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jMeido:					// Ch
			al05_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jKikori:					// ؂
			al06_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jYadoya:					// h
			al07_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jIchiba:					// s
			al08_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jSakaba:					// 
			al09_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jKateiKyousi:				// ƒ닳t
			al10_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jMeidoSakaba:				// Ch
			al11_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jAyasiiSakaba:				// 
			al12_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jKajino:					// JWm
			al13_end(g_schedule_run_no, g_schedule_tmp_end);
			break;
		case jYasumi:					
			break;
		case jBakansu:
			break;
		case jOdekake:					//PtF[Y
			break;
		case jRyouyou:
			break;
	}
}

//--------------------------------------------------
// XPW[s̐߂
//--------------------------------------------------
static void GetSchSucessParsent(void)
{
	s32
		val0, val1, val2,
		vals[][4] = 
		{
			{ 50, 150, 250, 350 },	// w
			{ 50, 175, 220, 300 },	// p
			{ 50, 180, 225, 320 },	// p
			{ 50, 150, 220, 320 },	// @
			{ 50, 240, 250, 350 },	// |p
			{ 50, 160, 190, 300 },	// 
		};

	switch (g_schedule_run_no)
	{
		case jZagaku:			// w
			val2 = (s32)getParam(pCHIRYOKU);
			val0 = vals[0][getSchRank(g_schedule_run_no)];
			break;
		case jBujyutu:			// p
			val2 = (s32)getParam(pBUJYUTU);
			val0 = vals[1][getSchRank(g_schedule_run_no)];
			break;
		case jMajyutu:			// p
			val2 = (s32)getParam(pMAJYUTU);
			val0 = vals[2][getSchRank(g_schedule_run_no)];
			break;
		case jReihou:			// @
			val2 = (s32)getParam(pKIHINN);
			val0 = vals[3][getSchRank(g_schedule_run_no)];
			break;
		case jGeijyutu:			// |p
			val2 = (s32)getParam(pKANNJYU);
			val0 = vals[4][getSchRank(g_schedule_run_no)];
			break;
		case jButou:			// 
			val2 = (s32)getParam(pMIRYOKU);
			val0 = vals[5][getSchRank(g_schedule_run_no)];
			break;
		case jKajiTetudai:		// Ǝ`
			val2 = (s32)getParam(pKIDATE);
			val0 = 25;
			break;
		case jKomori:			// q
			val2 = ((s32)getParam(pKANNJYU) + (s32)getParam(pKIDATE)) / 2;
			val0 = (25 + 30) / 2;
			break;
		case jNoujyou:			// _
			val2 = (s32)getParam(pTAIRYOKU);
			val0 = 100;
			break;
		case jKyoukai:			// 
			val2 = (s32)getParam(pMORAL);
			val0 = 30;
			break;
		case jRyouriya:			// 
			val2 = ((s32)getParam(pKANNJYU) + (s32)getParam(pKIDATE)) / 2;
			val0 = (30 + 25) / 2;
		case jMeido:			// Ch
			val2 = ((s32)getParam(pMIRYOKU) + (s32)getParam(pMORAL)) / 2;
			val0 = (60 + 50) / 2;
			break;
		case jKikori:			// ؂
			val2 = (s32)getParam(pTAIRYOKU);
			val0 = 300;
			break;
		case jYadoya:			// h
			val2 = ((s32)getParam(pTAIRYOKU) + (s32)getParam(pKIDATE)) / 2;
			val0 = (45 + 50) / 2;
			break;
		case jIchiba:			// s
			val2 = ((s32)getParam(pCHIRYOKU) + (s32)getParam(pKIDATE)) / 2;
			val0 = (200 + 150) / 2;
			break;
		case jSakaba:			// 
			val2 = ((s32)getParam(pMIRYOKU) + (s32)getParam(pKIDATE)) / 2;
			val0 = (100 + 60) / 2;
			break;
		case jKateiKyousi:		// ƒ닳t
			val2 = (s32)getParam(pCHIRYOKU);
			val0 = 250;
			break;
		case jMeidoSakaba:		// Ch
			val2 = ((s32)getParam(pMIRYOKU) + (s32)getParam(pKANNJYU)) / 2;
			val0 = (300 + 250) / 2;
			break;
		case jAyasiiSakaba:		// 
			val2 = ((s32)getParam(pMIRYOKU) + (s32)getParam(pKIHINN)) / 2;
			val0 = (350 + 50) / 2;
			break;
		case jKajino:			// JWm
			val2 = ((s32)getParam(pMIRYOKU) + (s32)getParam(pKIHINN)) / 2;
			val0 = (350 + 150) / 2;
			break;
	}
	if (getParam(pTAIRYOKU) == 0)
	{
		g_schedule_suc_per = 10;
	} else {
		val1 = ((s32)getParam(pHIROU) * 100) / ((s32)getParam(pTAIRYOKU) * 2);
		val0 = ((val2 + 10) * 100) / val0;
		g_schedule_suc_per = val0 - val1;
		if (g_schedule_suc_per < 10)
			g_schedule_suc_per = 10;
		else
		if (g_schedule_suc_per > 90)
			g_schedule_suc_per = 90;
	}
}


//---------------------------------------------------------
// i߂
//---------------------------------------------------------
static void NextDay(void)
{
	decBirth();
	cmdIncDay();
}
//---------------------------------------------------------
static void cmdIncDay(void)
{
	u8 y, m, d, w;

	getDays(&y, &m, &d, &w);
	w++;
	if (w == 7)
		w = 0;
	d++;
	if (d > getMaxday(m))
	{
		funcParamChangeEndOfMonth();
		setGameM((u8)(getGameM()+1));
		m++;
		d = 1;
		if (m > 12)
		{
			m = 1;
			y++;
		}
		setGameY((u8)(getGameM()/12));
		if (m == 3 || m == 4 || m == 5)
			setSeason(0);
		else
		if (m == 6 || m == 7 || m == 8)
			setSeason(1);
		else
		if (m == 9 || m == 10 || m == 11)
			setSeason(2);
		else
			setSeason(3);
	}
	setDays(y, m, d, w);
}

//---------------------------------------------------------
static void funcSetParamUpdateList(void)
{
	int i;

	for (i=0; i<28; i++)
	{
		if (g_param_add_value[i] != 0 || g_param_add_width[i] != 0)
			setParamName(i, TRUE);
		else
			setParamName(i, FALSE);
	}
	setParamNameObj();
}

//----------------------------------
// a
//----------------------------------
static void decBirth(void)
{
	u8 y, m, d, w, bm, bd, fbm, fbd;

	getDays(&y, &m, &d, &w);
	getBirth(&y, &bm, &bd);
	getFBirth(&y, &fbm, &fbd);
	if (m == bm && d == bd)
	{
		//Ea
		setLabel(LF_e_birth_4, ON);
	}
	if (getcon() == conN)
	{
		// sǂaC̏ꍇ́Aȉ̃`FbNȂ
		// 邤Ñ`FbN2/29aݒłȂ̂Ŗ
		if (m == fbm && d == fbd)
			setLabel(LF_e_birth_0, ON);		//Ea
	}

	// PNڂłȂAaCłȂ
	if (getGameY() != 0 && getcon() != conS)
	{
		//--------------------------
		//[[Ea
		// Niporpj>= 6 𖞂Ă邱
		//--------------------------
		if (getRvlEnc() == cLI && m == 4 && d == 14)
		{
			if (getSchCount(jBujyutu) / getGameY() >= 6 || getSchCount(jMajyutu) / getGameY() >= 6)
				setLabel(LF_ev151, ON);		// 6,12...(+6)
		}

		//--------------------------
		//NX`[iEa
		// Ni >= 6j𖞂Ă邱
		// Ái >= 3jƂ
		//--------------------------
		if (getRvlEnc() == cKR && m == 7 && d == 18)
		{
			if ((getSchCount(jButou)+3) / getGameY() >= 6)
				setLabel(LF_ev171, ON);		// 3,9...(+6)
		}

		//--------------------------
		//}[Ea
		// Ni|p >= 6j𖞂Ă邱
		// Ái|p >= 10jƂ
		//--------------------------
		if (getRvlEnc() == cMA && m == 1 && d == 17)
		{
			if ((getSchCount(jGeijyutu)-4) / getGameY() >= 6)
				setLabel(LF_ev192, ON);		// 10,16...(+6)
		}
	}
}


//----------------------------------
//
//----------------------------------
static void schYasumi(void)
{
	if (getGameM() == y1444_2 && getLabel(LF_ev011) == OFF)
	{
		putDateWindow(FALSE);	//	#cmd{ cmdCalendarClose }
		waitChangeGraph();
		setScript(_EV011_PSC, EV011_EV011);
		waitScript();
		if (getScriptEndCode() == 2)
		{
			// Rlő̂Ƃ
			setParamUp(pKIDATE, 500);
			setScript(_EV011_PSC, EV011_EV011_3);
			waitScript();
		}
		if (getScriptEndCode() == 0)
		{
			// ނɍs
			setParamUp(pTAIRYOKU, 500);
			setScript(_EV011_PSC, EV011_EV011_1);
			waitScript();
			addParam(pR1,  1000);			// [[
			addParam(pR2, -1000);			// NX`[i
		} else
		if (getScriptEndCode() == 1)
		{
			// ɍs
			setParamUp(pKIHINN, 500);
			setScript(_EV011_PSC, EV011_EV011_2);
			waitScript();
			addParam(pR1, -1000);			// [[
			addParam(pR2,  1000);			// NX`[i
		}
	}

	setChangeLock(TRUE);
	setBgNum(BG_bgr000);
	setChaNum(0, cDA0);
	setChangeLock(FALSE);
	waitChangeGraph();

	setBGM(SEQ_PRM4_21);
	playBGM();

	putDateWindow(TRUE);
	waitChangeGraph();

	if (getageWidth() == ageC)
		setScript(_RE01_PSC, RE01_RE01C);
	else
	if (getageWidth() == ageL)
		setScript(_RE01_PSC, RE01_RE01L);
	else
		setScript(_RE01_PSC, RE01_RE01H);
	waitScript();
	if (getScriptEndCode() == 0)
	{
		// 
		if (getageWidth() == ageC)
		{
			if (getGold() < 80)
			{
				setScript(_RE01_PSC, RE01_RE01_GOLD_00);
				waitScript();
				setLabel(LF_re01_4, ON);
				funcSetAddParamValueYasumi_1();
			} else {
				setScript(_RE01_PSC, RE01_RE01_GOLD_10);
				setAddGold(-80);
				waitScript();
				setLabel(LF_re01_1, ON);
				funcSetAddParamValueYasumi_0();
				if (getcon() == conY)
					setScript(_TK01_PSC, TK01_TK01_49);	//#call{ tk01_49 }
				else
					setScript(_RE01_PSC, RE01_RE01_1);
				waitScript();
			}
		} else
		if (getageWidth() == ageL)
		{
			if (getGold() < 100)
			{
				setScript(_RE01_PSC, RE01_RE01_GOLD_00);
				waitScript();
				setLabel(LF_re01_4, ON);
				funcSetAddParamValueYasumi_1();
			} else {
				setScript(_RE01_PSC, RE01_RE01_GOLD_20);
				setAddGold(-100);
				waitScript();
				setLabel(LF_re01_2, ON);
				funcSetAddParamValueYasumi_0();
				if (getcon() == conY)
					setScript(_TK01_PSC, TK01_TK01_50);	//#call{ tk01_50 }
				else
					setScript(_RE01_PSC, RE01_RE01_2);
				waitScript();
			}
		} else
		if (getageWidth() == ageH)
		{
			if (getGold() < 120)
			{
				setScript(_RE01_PSC, RE01_RE01_GOLD_00);
				waitScript();
				setLabel(LF_re01_4, ON);
				funcSetAddParamValueYasumi_1();
			} else {
				setScript(_RE01_PSC, RE01_RE01_GOLD_30);
				setAddGold(-120);
				waitScript();
				setLabel(LF_re01_3, ON);
				funcSetAddParamValueYasumi_0();
				if (getcon() == conY)
					setScript(_TK01_PSC, TK01_TK01_51);	//#call{ tk01_51 }
				else
					setScript(_RE01_PSC, RE01_RE01_3);
				waitScript();
			}
		}
	} else {
		// iV
		setLabel(LF_re01_4, ON);
		funcSetAddParamValueYasumi_1();
	}
	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	clearCha(3);
	setChangeLock(FALSE);
	waitChangeGraph();
	funcSetParamUpdateList();
//------------------------------
	if (schYasumiEvent() == 1)
	{
		// Event̏ꍇ
		putDateWindow(TRUE);
		waitChangeGraph();
		while (g_schedule_run_days > 0)
		{
			g_schedule_run_days--;
			incSchDays(g_schedule_run_no);	// s̉Z

			funcParamAddUpdate();
			if (g_schedule_run_days > 0)
			{
				NextDay();
				putDateWindow(TRUE);
				//waitChangeGraph();
			}
		}
	} else {
		// ʏ̗
		putScheduleAnim(20, 3);
		while (g_schedule_run_days > 0)
		{
			if (getRandom() % 100 < 50)
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHYASUMI1);
			else
				setScript(_SCHEDULE_PSC, SCHEDULE_SCHYASUMI2);
			funcParamAddUpdate();
			waitScript();

			g_schedule_run_days--;
			incSchDays(g_schedule_run_no);	// s̉Z

			if (g_schedule_run_days > 0)
			{
				NextDay();
				putDateWindow(TRUE);
				//waitChangeGraph();
			}
		}
		clearScheduleAnim();
		waitChangeGraph();
	}
}
//------------------------------------
// 2006 Insert ---->
static int schYasumiEvent(void)
{
	// EV300
	if (getGameM() >= y1442_12 && getGameM() <= y1443_2)
	{
		if (getLabel(LF_va02_3) == ON && getLabel(LF_ev300) == OFF)
		{
			// [[{NX`[i{}[ >= 15
			if (getParam(pR1) + getParam(pR2) + getParam(pR3) >=15)
			{
				putDateWindow(FALSE);
				setScript(_EV300_PSC, EV300_EV300);
				waitScript();
				return 1;
			}
		}
	}
	// EV302
	if (getGameM() >= y1442_2 && getGameM() <= y1442_3 && getParam(pFA) >= 30)
	{
		if (getLabel(LF_ev302) == OFF)
		{
			putDateWindow(FALSE);
			setScript(_EV302_PSC, EV302_EV302);
			waitScript();
			return 1;
		}
	}
	// EV310
	if (getGameM() >= y1443_10 && getGameM() <= y1443_11)
	{
		if (getLabel(LF_ev310) == OFF)
		{
			// [[{NX`[i{}[ >= 50
			if (getParam(pR1) + getParam(pR2) + getParam(pR3) >=50)
			{
				putDateWindow(FALSE);
				setScript(_EV310_PSC, EV310_EV310);
				waitScript();
				return 1;
			}
		}
	}
	// EV311
	if (getGameM() >= y1446_6 && getGameM() <= y1446_8)
	{
		if (getLabel(LF_ev311) == OFF)
		{
			// [[{NX`[i{}[ >= 80
			if (getParam(pR1) + getParam(pR2) + getParam(pR3) >= 80)
			{
				putDateWindow(FALSE);
				setScript(_EV311_PSC, EV311_EV311);
				waitScript();
				if (getScriptEndCode() == 0)
					addParam(pR2, 100);	// NX`[i
				return 1;
			}
		}
	}
	return 0;
}
//--------------------------------------------------
// x݂̃p[^ϓlݒ
// ijÂꍇ
//--------------------------------------------------
static void funcSetAddParamValueYasumi_0(void)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;

	g_param_add_value[pHIROU] = -500 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
}

//--------------------------------------------------
// x݂̃p[^ϓlݒ
// ijÂȂꍇ
//--------------------------------------------------
static void funcSetAddParamValueYasumi_1(void)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;

	g_param_add_value[pHIROU] = -300 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
}

//--------------------------------------
// ×{
//--------------------------------------
static void schRyouyou(void)
{
	setBGM(SEQ_PRM4_37);
	playBGM();
	setBgNum(BG_bgr000);
	waitChangeGraph();

	putDateWindow(TRUE);
	waitChangeGraph();

	setLabel(LF_re02_0, ON);
	setLabel(LF_re02_1, OFF);		//SDp×{^@Ɏgp
	setScript(_RE02_PSC, RE02_RE02);
	waitScript();
	if (getScriptEndCode() == 0)
	{
		// @
		funcSetAddParamValueRyouyou_1();
		setLabel(LF_re02_10, ON);
	} else {
		// ×{
		funcSetAddParamValueRyouyou_0();
		setLabel(LF_re02_1, ON);
		if (getScriptEndCode() == 1)
		{
			// Ŋŕa
			g_gold_add_value = -10;
			g_param_add_value[pFA] = 100;
			setLabel(LF_re02_2, ON);
		} else {
			// L[uŕa
			setLabel(LF_re02_6, ON);
			g_param_add_value[pCU] = 100;	//L[u{P
		}
	}
	funcSetParamUpdateList();

	if (getLabel(LF_re02_1) == ON)
		putScheduleAnim(21, 3);
	else
		putScheduleAnim(22, 3);

	while (g_schedule_run_days > 0)
	{
		if (getLabel(LF_re02_1) == OFF && getGold() < 50)
		{
			setLabel(LF_re02_1, ON);
			setScript(_SCHEDULE_PSC, SCHEDULE_SCHRYOUYOU);
			waitScript();
			funcSetAddParamValueRyouyou_0();
			putScheduleAnim(21, 3);
		}

		funcParamAddUpdate();
		if (getOptionMessage() == 0)
			waitOnly(10);
		else
			waitOnly(30);
		waitChangeGold();

		g_schedule_run_days--;
		incSchDays(g_schedule_run_no);	// s̉Z

		if (g_schedule_run_days > 0)
		{
			NextDay();
			putDateWindow(TRUE);
			//waitChangeGraph();
		}
	}
	clearScheduleAnim();
	waitChangeGraph();
}
//--------------------------------------------------
// ×{̃p[^ϓlݒ
// ijA
//--------------------------------------------------
static void funcSetAddParamValueRyouyou_0(void)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;

	g_param_add_value[pHIROU] = -1000 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
}

//--------------------------------------------------
// ×{̃p[^ϓlݒ
// ija@
//--------------------------------------------------
static void funcSetAddParamValueRyouyou_1(void)
{
	funcClearAddParamValue();
	g_gold_add_value = -50;

	g_param_add_value[pHIROU] = -2000 * (100+((s32)getParam(pTAIRYOKU)+1)/20)/100;
}

//--------------------------------------
// oJX
//--------------------------------------
static void schBakansu(void)
{
	setBGM(SEQ_PRM4_21);
	playBGM();
	setChangeLock(TRUE);
	putDateWindow(FALSE);	//	#cmd{ cmdCalendarClose }
	setBgNum(BG_bgr000);	// #m_roomBg
	setChangeLock(FALSE);
	waitChangeGraph();


	if (getGold() < 30)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_SCHBAKANSU);
		waitScript();
		g_schedule_run_no = jYasumi;
		schYasumi();
		return;
	}

	setLabel(LF_va01_0, OFF);	//stONA
	va00();
	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	putDateWindow(TRUE);
	setChangeLock(FALSE);
	waitChangeGraph();

	funcClearAddParamValue();
	funcSetAddParamValue();
	funcSetParamUpdateList();

	while (g_schedule_run_days > 0)
	{
		if (getGold() < 30 && getLabel(LF_va01_0) == OFF)
		{
			setLabel(LF_va01_0, ON);			//stOnm
			//oJXG̃NA
			setScript(_SCHEDULE_PSC, SCHEDULE_SCHBAKANSUKITAKU);
			funcClearAddParamValue();
			g_param_add_value[pHIROU] = -200;
			g_param_add_value[pFA] = -100;
			funcSetParamUpdateList();
			waitScript();
		}

		g_schedule_run_days--;
		incSchDays(g_schedule_run_no);	// s̉Z

		funcParamAddUpdate();
		if (getOptionMessage() == 0)
			waitOnly(10);
		else
			waitOnly(30);
		waitChangeGold();
		if (g_schedule_run_days > 0)
		{
			NextDay();
			putDateWindow(TRUE);
			//waitChangeGraph();
		}
	}
	fadeBGM(30);
	if (getLabel(LF_va01_0) == OFF)
	{
		setScript(_VA00_PSC, VA00_VA00_END);
		waitScript();
	}
	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}
// -------------------------------------
// oCgEdS{[iX
// -------------------------------------
void perfectBon(void)
{
	u32 old;

	if (g_schedule_run_no >= jKomori && g_schedule_run_no <= jAyasiiSakaba)
	{
		setAddGold(getScheduleGold(g_schedule_run_no) * g_schedule_good / 2);
	}
	old = getParam(pCHIMEI);
	setParamName(pCHIMEI, TRUE);
	setParamNameObj();
	addParam(pCHIMEI, 100);
	if (old != getParam(pCHIMEI))
		setParamColor(pCHIMEI, 1);
	setParamObj();
	setParamColor(pCHIMEI, 0);
}


//--------------------------------------
// o
//--------------------------------------
static void schOdekake(void)
{
	u8 days;
	BOOL end_req;
	int i;

	waitChangeGold();
	setScriptGraph();
	initSelectMap();

	end_req = FALSE;
	g_gate_travel = FALSE;
	init_map_check_first();		// 
	while (getMapMoveCount() > 0 && !end_req)
	{
		setSelectMap();
		if (getMapType() == MAP_TYPE_TOWN)
		{
			//ADV02(4/7)
			// adv02_5_hint
			if (getLabel(LF_adv02_5) == OFF && getLabel(LF_adv02_5_hint) == ON && getLabel(LF_adv02_5_hint_disable) == OFF)
			{
				setScript(_ADV02_PSC, ADV02_ADV02_5_HINT);
				waitScript();
			}
		} else {
			//ADV02/ACT7 -- MAPŌĂяo
			if (getLabel(LF_adv02_5) == ON && getLabel(LF_adv02_6) == OFF)
			{
				setScript(_ADV02_PSC, ADV02_ADV02_6);
				waitScript();
			}
			//ACT4 -- MAPŌĂяo
			if (getLabel(LF_adv02_2) == ON && getLabel(LF_adv02_3) == OFF)
			{
				setScript(_ADV02_PSC, ADV02_ADV02_3);
				waitScript();
			}
			if (getLabel(LF_at01_0) == OFF)
			{
				setScript(_AT00_PSC, AT00_AT01_0);	//߂Ă̖E
				waitScript();
			}
		}

		init_map_check();		// 
		startMapSelect();
		waitMapSelect();
		if (getMapType() == MAP_TYPE_TOWN)
		{
			switch (getMapResult())
			{
				case -1:	// A
					clearMap();
					setParamGraph();
					waitChangeGraph();
					setScript(_SCHEDULE_PSC, SCHEDULE_SCHODEKAKEKITAKU);
					waitScript();
					end_req = TRUE;
					break;
				case 0:		//
					ca00();
					break;
				case 1:		//L
					tw05();
					break;
				case 2:		//s
					tw06();
					break;
				case 3:		//X
					tw07();
					break;
				case 4:		//ɉ؊X
					tw01();
					break;
				case 5:		//
					tw02();
					break;
				case 6:		//Xg
					tw04();
					break;
				case 7:		//miX
					tw03();
					break;
				case 8:		//
					tw09();
					break;
				case 9:		//a@
					tw08();
					break;
				case 10:	//_[N^E
					tw10();
					break;
			}
		} else {
			switch (getMapResult())
			{
				case -1:
					//ADV01(1/5)
					if (getGameM() >= y1447_4 && getGameM() <= y1447_6 && g_schedule_phase == 0)
					{
						if (getLabel(LF_adv01_0) == OFF && getLabel(LF_ev033) == ON &&
							getLabel(LF_ev016) == ON && getLabel(LF_ev020_0) == ON)
						{
							setevm_adv01(getGameM());
							setScript(_ADV01_PSC, ADV01_ADV01_0);
							waitScript();
						}
					}
					g_gate_travel = TRUE;
					break;
				case 11:		//
					ac00();
					break;
				case 12:		//X
					at03();
					break;
				case 13:		//
					at02();
					break;
				case 14:		//
					ev030();
					break;
				case 15:		//J
					at04();
					break;
				case 16:		//L
					at01();
					break;
			}
		}

		for (i=0; i<28; i++)
			setParamName(i, FALSE);
		setParamNameObj();
		setChangeLock(TRUE);
		clearCha(3);
		putDateWindow(TRUE);
		clearFaceName();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setChangeLock(FALSE);
		waitChangeGraph();

		if (g_gate_travel)
		{
			changeMap();
			g_gate_travel = FALSE;
			continue;
		}

		if (end_req || getMapMoveCount() == 0)
			days = g_schedule_run_days;
		else
			days = 3;

		funcClearAddParamValue();

		while (days > 0)
		{
			g_schedule_run_days--;
			days--;
			incSchDays(g_schedule_run_no);	// s̉Z

			if (getOptionMessage() == 0)
				waitOnly(10);
			else
				waitOnly(30);
			waitChangeGold();

			if (g_schedule_run_days > 0)
			{
				NextDay();
				putDateWindow(TRUE);
				//waitChangeGraph();
			}
		}
	}
	funcSetAddParamValue();
	funcSetParamUpdateList();
	funcParamAddUpdate();
	if (getOptionMessage() == 0)
		waitOnly(30);
	else
		waitOnly(60);


	if (getLabel(LF_ev085_0) == ON && getLabel(LF_ev032_0) == OFF)
	{
		// schOdekakeEnd͂ƂĂȂ悤ȋC邪EEE
		return;
	}

	// adv01_0`FbNĂǔIɂ肦Ȃ̂ō폜

	if (!end_req)
	{
		setMapBg();
		setScript(_SCHEDULE_PSC, SCHEDULE_SCHODEKAKEEND);
		waitScript();
	}
}

//--------------------------------------
void setGateTravel(void)
{
	g_gate_travel = TRUE;
}

//--------------------------------------
// VKɒǉꂽXPW[̕
//--------------------------------------
static void newScheduleGuide(void)
{
	BOOL mes_put;

	mes_put = FALSE;
	// 
	if (getNewSchGuide(jButou) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEA);
		waitScript();
		setNewSchGuide(jButou, OFF);
		mes_put = TRUE;
	}
	// @
	if (getNewSchGuide(jReihou) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEB);
		waitScript();
		setNewSchGuide(jReihou, OFF);
		mes_put = TRUE;
	}
	// ƒ닳t
	if (getNewSchGuide(jKateiKyousi) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEC);
		waitScript();
		setNewSchGuide(jKateiKyousi, OFF);
		mes_put = TRUE;
	}
	// iXgj
	if (getNewSchGuide(jRyouriya) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDED);
		waitScript();
		setNewSchGuide(jRyouriya, OFF);
		mes_put = TRUE;
	}
	// s
	if (getNewSchGuide(jIchiba) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEE);
		waitScript();
		setNewSchGuide(jIchiba, OFF);
		mes_put = TRUE;
	}
	// ؂
	if (getNewSchGuide(jKikori) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEF);
		waitScript();
		setNewSchGuide(jKikori, OFF);
		mes_put = TRUE;
	}
	// Ch
	if (getNewSchGuide(jMeido) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEG);
		waitScript();
		setNewSchGuide(jMeido, OFF);
		mes_put = TRUE;
	}
	// 
	if (getNewSchGuide(jSakaba) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEH);
		waitScript();
		setNewSchGuide(jSakaba, OFF);
		mes_put = TRUE;
	}
	// JWm
	if (getNewSchGuide(jKajino) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEI);
		waitScript();
		setNewSchGuide(jKajino, OFF);
		mes_put = TRUE;
	}
	// Ch
	if (getNewSchGuide(jMeidoSakaba) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEJ);
		waitScript();
		setNewSchGuide(jMeidoSakaba, OFF);
		mes_put = TRUE;
	}
	// ₵
	if (getNewSchGuide(jAyasiiSakaba) == ON)
	{
		setScript(_SCHEDULE_PSC, SCHEDULE_NEWSCHEDULEGUIDEK);
		waitScript();
		setNewSchGuide(jAyasiiSakaba, OFF);
		mes_put = TRUE;
	}
	// h
	// h͕ʂ̏ꏊŕ񍐂Ă邽߁Aɂ͓Ȃ

	if (mes_put)
	{
		setChangeLock(TRUE);
		clearFaceName();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setChangeLock(FALSE);
		waitChangeGraph();
	}
}
//--------------------------------------
// p[^Abv\Ăяo
//--------------------------------------
void setParamUp(u8 in_para, s32 in_num)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;
	g_param_add_value[in_para] = in_num;
	funcSetParamUpdateList();
	funcParamAddUpdate();
}
//--------------------------------------
void setParamUp2(u8 in_para1, s32 in_num1, u8 in_para2, s32 in_num2)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;
	g_param_add_value[in_para1] = in_num1;
	g_param_add_value[in_para2] = in_num2;
	funcSetParamUpdateList();
	funcParamAddUpdate();
}
//--------------------------------------
void setParamUp3(u8 in_para1, s32 in_num1, u8 in_para2, s32 in_num2, u8 in_para3, s32 in_num3)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;
	g_param_add_value[in_para1] = in_num1;
	g_param_add_value[in_para2] = in_num2;
	g_param_add_value[in_para3] = in_num3;
	funcSetParamUpdateList();
	funcParamAddUpdate();
}
//--------------------------------------
void setParamUp4(u8 in_para1, s32 in_num1, u8 in_para2, s32 in_num2, u8 in_para3, s32 in_num3, u8 in_para4, s32 in_num4)
{
	funcClearAddParamValue();
	g_gold_add_value = 0;
	g_param_add_value[in_para1] = in_num1;
	g_param_add_value[in_para2] = in_num2;
	g_param_add_value[in_para3] = in_num3;
	g_param_add_value[in_para4] = in_num4;
	funcSetParamUpdateList();
	funcParamAddUpdate();
}
//--------------------------------------
void setParamUpAll(s32 *in_num)
{
	int i;

	funcClearAddParamValue();
	g_gold_add_value = 0;
	for (i=0; i<28; i++)
		g_param_add_value[i] = in_num[i];
	funcSetParamUpdateList();
	funcParamAddUpdate();
}
//--------------------------------------
u8 getSchPhase(void)
{
	return g_schedule_phase;
}


//--------------------------------------
// 
//--------------------------------------
static void e_nfd(void)
{
	setParamObj();
	putDateWindow(FALSE);
	waitChangeGraph();
	setScript(_E_NFD_PSC, E_NFD_E_NFD);
	waitScript();
	if (getYear() == 1441)
	{
		setScript(_E_NFD_PSC, E_NFD_E_NFD_INTRO);
		waitScript();
	}
	if (getcon() == conS)
	{
		// aC̎̏
		if (getageWidth() == ageC)
			setScript(_E_NFD_PSC, E_NFD_NFD_CONS_C);
		else
		if (getageWidth() == ageL)
			setScript(_E_NFD_PSC, E_NFD_NFD_CONS_L);
		else
			setScript(_E_NFD_PSC, E_NFD_NFD_CONS_H);
		waitScript();
		return;
	}
	setScript(_E_NFD_PSC, E_NFD_NFD_SEL);
	waitScript();
	if (getScriptEndCode() == 1)
		return;
	if (getcon() == conY)
	{
		//ՁFsǂŋ
		if (getageWidth() == ageC)
			setScript(_E_NFD_PSC, E_NFD_NFD_CONY_C);
		else
		if (getageWidth() == ageL)
			setScript(_E_NFD_PSC, E_NFD_NFD_CONY_L);
		else
			setScript(_E_NFD_PSC, E_NFD_NFD_CONY_H);
		waitScript();
		return;
	}
	if (getGameY() != 7)
	{
		setScript(_E_NFD_PSC, E_NFD_NFD_GO_1);
		waitScript();
	}
	setChangeLock(TRUE);
	clearFaceName();
	putFaceWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	switch (getGameY())
	{
		case 0:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			if (getParam(pKIHINN) >= 35)
				setScript(_E_NFD_PSC, E_NFD_E_NFD_1);
			else
				setScript(_E_NFD_PSC, E_NFD_E_NFD_2);
			waitScript();
			break;
		case 1:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			if (getParam(pKIHINN) >= 100)
				setScript(_E_NFD_PSC, E_NFD_E_NFD_11);
			else
				setScript(_E_NFD_PSC, E_NFD_E_NFD_12);
			waitScript();
			break;
		case 2:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			if (getLabel(LF_ca03_0) == ON)
				setScript(_E_NFD_PSC, E_NFD_E_NFD_3);
			else
				setScript(_E_NFD_PSC, E_NFD_E_NFD_4);
			waitScript();
			break;
		case 3:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			setScript(_E_NFD_PSC, E_NFD_E_NFD_5);
			waitScript();
			break;
		case 4:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setScript(_EV019_PSC, EV019_EV019);
			waitScript();
			break;
		case 5:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			if (getParam(pBUJYUTU) >= getParam(pMAJYUTU) && getParam(pBUJYUTU) >= getParam(pKIHINN))
			{
				setScript(_E_NFD_PSC, E_NFD_E_NFD_8);
				waitScript();
				setParamUp(pBUJYUTU, 1000);
			} else
			if (getParam(pKIHINN) >= getParam(pMAJYUTU) && getParam(pKIHINN) >= getParam(pBUJYUTU))
			{
				setScript(_E_NFD_PSC, E_NFD_E_NFD_6);
				waitScript();
				setParamUp(pKIHINN, 1000);
			} else
			if (getParam(pMAJYUTU) >= getParam(pBUJYUTU) && getParam(pMAJYUTU) >= getParam(pKIHINN))
			{
				setScript(_E_NFD_PSC, E_NFD_E_NFD_7);
				waitScript();
				setParamUp(pMAJYUTU, 1000);
			}
			break;
		case 6:
			setBgNum(BG_har_bg02);
			waitChangeGraph();
			setBgNum(BG_bg03);
			waitChangeGraph();
			setScript(_E_NFD_PSC, E_NFD_E_NFD_9);
			waitScript();
			break;
		case 7:
			setLabel(LF_e_nfd_10_DEBU, OFF);
			setLabel(LF_ev034, OFF);
			if (isItem(57) == -1 && isItem(61) == -1 && isItem(62) == -1 && isItem(63) == -1 && isItem(82) == -1 && isItem(83) == -1)
			{
				// hXĂȂ
				setScript(_E_NFD_PSC, E_NFD_NFD_GO_2);
				waitScript();
			} else
			if (getBMI() > 249)
			{
				// 肷ŁAhXȂꍇ
				setScript(_E_NFD_PSC, E_NFD_NFD_GO_3);
				waitScript();
			} else {
				setScript(_E_NFD_PSC, E_NFD_NFD_GO_4);
				waitScript();
				funcSetMyDress();
				setScript(_E_NFD_PSC, E_NFD_NFD_GO_5);
				waitScript();
				putStartMessage();
				waitSelectShop();
				item_dress2(getSelectItem(), ON);
				setLabel(LF_ev034, ON);
			}
			setChangeLock(TRUE);
			clearMessage();
			clearFaceName();
			putFaceWindow(FALSE);
			putMessageWindow(FALSE);
			setBgNum(BG_har_bg02);
			setChangeLock(FALSE);
			waitChangeGraph();
			if (getLabel(LF_ev019) == ON && getLabel(LF_ev034) == ON)
			{
				setScript(_EV034_PSC, EV034_EV034);
				waitScript();
				//ŗꂪ܂BDxp[^[Ń[gω
				if (getParam(pPR) > 50)
				{
					//̗
					setScript(_EV034_PSC, EV034_EV034_2);
					waitScript();
					//CxgGiVƖj
					switch (getDress())
					{
						case 4:			// item61(hX)
							setBgNum(BG_ev34a);
							break;
						case 5:			// item62(VÑhX)
							setBgNum(BG_ev34b);
							break;
						case 6:			// item63(؂ȃhX)
						case 17:		// item57(X̃[u)
						case 18:		// item83(P̃hX)
						case 19:		// item82(̃hX)
							setBgNum(BG_ev34c);
							break;
					}
					setScript(_EV034_PSC, EV034_EV34IMAGE);
					waitScript();
					if (getScriptEndCode() == 0)
					{
						setParamUp(pCHIMEI, 2000);
						setScript(_EV034_PSC, EV034_EV034_3);
						waitScript();
					} else
					if (getScriptEndCode() == 1)
					{
						setParamUp(pPRIDE, 2000);
						setScript(_EV034_PSC, EV034_EV034_4);
						waitScript();
					} else {
						setParamUp(pKIDATE, 2000);
						setScript(_EV034_PSC, EV034_EV034_5);
						waitScript();
					}

				} else {
					//NX`[i̗
					setScript(_EV034_PSC, EV034_EV034_1);
					waitScript();
				}
			} else {
				setBgNum(BG_bg03);
				waitChangeGraph();
				if (getLabel(LF_ev034) == OFF)
				{
					// hXAȂꍇ
					setScript(_E_NFD_PSC, E_NFD_E_NFD_10_1);
					waitScript();
					if (getLabel(LF_e_nfd_10_DEBU) != ON)
					{
						setScript(_E_NFD_PSC, E_NFD_E_NFD_10_2);
						waitScript();
					} else {
						setScript(_E_NFD_PSC, E_NFD_E_NFD_10_3);
						waitScript();
					}
				} else {
					setScript(_E_NFD_PSC, E_NFD_E_NFD_10_4);
					waitScript();
					setParamUp(pKIHINN, 1000);
					setScript(_E_NFD_PSC, E_NFD_E_NFD_10_5);
					waitScript();
				}
			}
			break;
	}
	setScript(_E_NFD_PSC, E_NFD_NFD_END);
	waitScript();
}


//--------------------------------------
// Ɩ̒a
//--------------------------------------
static void e_birth(void)
{
	setParamObj();
	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
	//-------------------------------------
	// aE
	//-------------------------------------
	if (getLabel(LF_ev151) == ON)
	{
		// [[̒a
		setLabel(LF_ev151, OFF);
		setChangeLock(TRUE);
		putDateWindow(FALSE);
		setBgNum(BG_map01);
		setChangeLock(FALSE);
		waitChangeGraph();
		setBGM(SEQ_PRM4_32);
		playBGM();
		if (getageWidth() == ageC)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV152_0);
		else
		if (getageWidth() == ageL)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV152_1);
		else
			setScript(_E_BIRTH_PSC, E_BIRTH_EV152_2);
		waitScript();
	}
	if (getLabel(LF_ev171) == ON)
	{
		// NX`[i̒a
		setLabel(LF_ev171, OFF);
		setChangeLock(TRUE);
		putDateWindow(FALSE);
		setBgNum(BG_map01);
		setChangeLock(FALSE);
		waitChangeGraph();
		setBGM(SEQ_PRM4_32);
		playBGM();
		if (getageWidth() == ageC)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV171_3);
		else
		if (getageWidth() == ageL)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV171_4);
		else
			setScript(_E_BIRTH_PSC, E_BIRTH_EV171_5);
		waitScript();
	}
	if (getLabel(LF_ev192) == ON)
	{
		// }[̒a
		setLabel(LF_ev192, OFF);
		setChangeLock(TRUE);
		putDateWindow(FALSE);
		setBgNum(BG_map01);
		setChangeLock(FALSE);
		waitChangeGraph();
		setBGM(SEQ_PRM4_32);
		playBGM();
		if (getageWidth() == ageC)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV192_3);
		else
		if (getageWidth() == ageL)
			setScript(_E_BIRTH_PSC, E_BIRTH_EV192_4);
		else
			setScript(_E_BIRTH_PSC, E_BIRTH_EV192_5);
		waitScript();
	}
	// CoajCxg֘A
	if (getLabel(LF_e_birth_4) == ON)
	{
		// PNڂłȂAaCłȂ
		if (getGameY() != 0 && getcon() != conS)
		{
			if (getRvlEnc() == cLI)
			{
				//--------------------------
				// ̒ai[[jj
				// Niporpj>= 6 𖞂Ă邱
				//--------------------------
				if (getLabel(LF_ev038) == OFF && getGameM() != y1445_2 && getGameM() != y1447_10 && (getSchCount(jBujyutu) / getGameY() >= 6 || getSchCount(jMajyutu) / getGameY() >= 6))
				{
					// 6,12...(+6)
					setChangeLock(TRUE);
					putDateWindow(FALSE);
					setBgNum(BG_map01);
					setChangeLock(FALSE);
					waitChangeGraph();
					setBGM(SEQ_PRM4_32);
					playBGM();
					if (getageWidth() == ageC)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV151_0);
					else
					if (getageWidth() == ageL)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV151_1);
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_EV151_2);
					waitScript();
				}
			} else
			if (getRvlEnc() == cKR)
			{
				//--------------------------
				// ̒aiNX`[ijj
				// Ni >= 6j𖞂Ă邱
				// Ái >= 3jƂ
				//--------------------------
				if ((getSchCount(jButou) + 3) / getGameY() >= 6)
				{
					// 3,9...(+6)
					setChangeLock(TRUE);
					putDateWindow(FALSE);
					setBgNum(BG_map01);
					setChangeLock(FALSE);
					waitChangeGraph();
					setBGM(SEQ_PRM4_32);
					playBGM();
					if (getageWidth() == ageC)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV171_0);
					else
					if (getageWidth() == ageL)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV171_1);
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_EV171_2);
					waitScript();
				}
			} else
			if (getRvlEnc() == cMA)
			{
				//--------------------------
				// ̒ai}[jj
				// Ni|p >= 6j𖞂Ă邱
				//--------------------------
				if (getSchCount(jGeijyutu) / getGameY() >= 6)
				{
					// 6,12...(+6)
					setChangeLock(TRUE);
					putDateWindow(FALSE);
					setBgNum(BG_map01);
					setChangeLock(FALSE);
					waitChangeGraph();
					setBGM(SEQ_PRM4_32);
					playBGM();
					if (getageWidth() == ageC)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV192_0);
					else
					if (getageWidth() == ageL)
						setScript(_E_BIRTH_PSC, E_BIRTH_EV192_1);
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_EV192_2);
					waitScript();
				}
			}
		}
		//---------------------------------------------------
		setAge((u8)(getAge()+1));
		setChangeLock(TRUE);
		putDateWindow(FALSE);
		setBgNum(BG_bgr000);
		setChangeLock(FALSE);
		waitChangeGraph();
		setLabel(LF_e_birth_4, OFF);
		setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_4);
		waitScript();
		putMessageWindow(FALSE);
		if (getScriptEndCode() == 0)
		{
			//aFȂ
			addParam(pFA, -500);
		} else {
			//iapjI[v
			if (sp01b() != -1)
			{
				//̕ԓieNƁj
				if (getGameY() == 0)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_5Y);	// 10
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_5S);	// 10
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_5);		// 10
				} else
				if (getGameY() == 1)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_6Y);	// 11
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_6S);	// 11
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_6);		// 11
				} else
				if (getGameY() == 2)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_7);		// 12
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_7);		// 12
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_7);		// 12
				} else
				if (getGameY() == 3)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_8);		// 13
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_8);		// 13
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_8);		// 13
				} else
				if (getGameY() == 4)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_9);		// 14
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_9);		// 14
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_9);		// 14
				} else
				if (getGameY() == 5)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_10);	// 15
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_10);	// 15
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_10);	// 15
				} else
				if (getGameY() == 6)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_11);	// 16
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_11);	// 16
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_11);	// 16
				} else
				if (getGameY() == 7)
				{
					if (getcon() == conY)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_12);	// 17
					else
					if (getcon() == conS)
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_12);	// 17
					else
						setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_12);	// 17
				}
				waitScript();
				//v[gɂp[^㏸o
				addParam(pFA, 500);
			} else {
				setLabel(LF_GrumbleBirth, ON);		// s䎌̗\
				addParam(pFA, -500);
				setScript(_E_BIRTH_PSC, E_BIRTH_AWARE);
				waitScript();
			}
			putMessageWindow(FALSE);
		}
	}
	setParamGraph();
	waitChangeGraph();

	if (getParam(pFA) > 5 * (getGameY()+1))
	{
		if (getLabel(LF_e_birth_0) == ON)
		{
			setChangeLock(TRUE);
			putDateWindow(FALSE);
			setBgNum(BG_bgr000);
			setChangeLock(FALSE);
			waitChangeGraph();
			setBGM(SEQ_PRM4_32);
			playBGM();
			setLabel(LF_e_birth_0, OFF);
			if (getageWidth() == ageC)
				setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_1);
			else
			if (getageWidth() == ageL)
				setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_2);
			else
				setScript(_E_BIRTH_PSC, E_BIRTH_E_BIRTH_3);
			waitScript();
			setParamUp(pKIDATE, 500);
			putStartMessage();
			waitScriptMessage();

			putMessageWindow(FALSE);
		}
	} else
		setLabel(LF_e_birth_0, OFF);

	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}


//--------------------------------------
// a
//--------------------------------------
static void e_holi(void)
{
	setParamObj();
	setChangeLock(TRUE);
	putDateWindow(FALSE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_bgr000);
	setChangeLock(FALSE);
	waitChangeGraph();

	if (getcon() == conS)
	{
		if (getYear() == 1440)
		{
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONS);
			waitScript();
		} else {
			if (getageWidth() == ageC)
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONS_C);
			else
			if (getageWidth() == ageL)
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONS_L);
			else
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONS_H);
			waitScript();
		}
		return;
	}
	if (getcon() == conY)
	{
		if (getYear() == 1440)
		{
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONY);
			waitScript();
		} else {
			if (getageWidth() == ageC)
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONY_C);
			else
			if (getageWidth() == ageL)
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONY_L);
			else
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_CONY_H);
			waitScript();
		}
		return;
	}
	switch (getYear())
	{
		case 1440:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_0);
			waitScript();
			setScript(_E_HOLI_PSC, E_HOLI_EV003);
			waitScript();
			if (getScriptEndCode() == 0)
			{
				//I//`Fق߂//Mx{T
				addParam(pFA, 500);
			} else
			if (getScriptEndCode() == 1)
			{
				//aFnqɂߑƌ//Mx[T
				addParam(pFA, -500);
			}
			setScript(_E_HOLI_PSC, E_HOLI_EV003_4);
			waitScript();
			break;
		case 1441:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
			waitScript();
			//v[g𔃂ꍇƂȂꍇŕʃViI
			if (getGold() < 1)
				setScript(_E_HOLI_PSC, E_HOLI_EV005_0);
			else
				setScript(_E_HOLI_PSC, E_HOLI_EV005);
			waitScript();
			break;
		case 1442:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
			waitScript();
			setChangeLock(TRUE);
			clearMessage();
			clearFaceName();
			putFaceWindow(FALSE);
			putMessageWindow(FALSE);
			setChangeLock(FALSE);
			waitChangeGraph();
			setScript(_E_HOLI_PSC, E_HOLI_EV009);
			waitScript();
			break;
		case 1443:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
			waitScript();
			setScript(_E_HOLI_PSC, E_HOLI_EV013);
			waitScript();
			break;
		case 1444:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
			waitScript();
			setScript(_E_HOLI_PSC, E_HOLI_EV017);
			waitScript();
			if (getScriptEndCode() == 0)
			{
				setParamUp2(pMORAL, 1000, pKIDATE, -1000);
				setScript(_E_HOLI_PSC, E_HOLI_EV017_1);
			} else
			if (getScriptEndCode() == 1)
			{
				setParamUp2(pTAIRYOKU, 1000, pMORAL, -500);
				setScript(_E_HOLI_PSC, E_HOLI_EV017_2);
			} else {
				addParam(pFA, 500);
				setScript(_E_HOLI_PSC, E_HOLI_EV017_3);
			}
			waitScript();
			break;
		case 1445:
			if (getLabel(LF_ev019) == OFF && getLabel(LF_ev020_0) == OFF && getLabel(LF_ev016) == OFF)
			{
				//jȂ
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
				waitScript();
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1A);
				waitScript();
			} else {
				//
				if (getParam(pPR) != 0 && getParam(pPR) >= getParam(pDY) && getParam(pPR) >= getParam(pDP) && getLabel(LF_ev019) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//V
					setScript(_E_HOLI_PSC, E_HOLI_EV021_0);
					waitScript();
				} else
				if (getParam(pDP) != 0 && getParam(pDP) >= getParam(pDY) && getParam(pDP) >= getParam(pPR) && getLabel(LF_ev020_0) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//@A
					setScript(_E_HOLI_PSC, E_HOLI_EV021_1);
					waitScript();
				} else
				if (getParam(pDY) != 0 && getParam(pDY) >= getParam(pPR) && getParam(pDY) >= getParam(pDP) && getLabel(LF_ev016) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//[
					setScript(_E_HOLI_PSC, E_HOLI_EV021_2);
					waitScript();
				} else {
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
					waitScript();
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1A);
					waitScript();
				}
			}
			break;
		case 1446:
			if (getLabel(LF_ev019) == OFF && getLabel(LF_ev020_0) == OFF && getLabel(LF_ev016) == OFF)
			{
				//jȂ
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
				waitScript();
				setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1A);
				waitScript();
			} else {
				//
				if (getParam(pPR) != 0 && getParam(pPR) >= getParam(pDY) && getParam(pPR) >= getParam(pDP) && getLabel(LF_ev019) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//V
					setScript(_E_HOLI_PSC, E_HOLI_EV021_3);
					waitScript();
				} else
				if (getParam(pDP) != 0 && getParam(pDP) >= getParam(pDY) && getParam(pDP) >= getParam(pPR) && getLabel(LF_ev020_0) == ON && getLabel(LF_ev028) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//@A
					setScript(_E_HOLI_PSC, E_HOLI_EV021_4);
					waitScript();
				} else
				if (getParam(pDY) != 0 && getParam(pDY) >= getParam(pPR) && getParam(pDY) >= getParam(pDP) && getLabel(LF_ev016) == ON)
				{
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_2);
					waitScript();
					//[
					setScript(_E_HOLI_PSC, E_HOLI_EV021_5);
					waitScript();
				} else {
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
					waitScript();
					setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1A);
					waitScript();
				}
			}
			break;
		case 1447:
			setScript(_E_HOLI_PSC, E_HOLI_E_HOLI_1);
			waitScript();
			setScript(_E_HOLI_PSC, E_HOLI_EV043);
			waitScript();
			break;
	}

	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_bgr000);
	setChangeLock(FALSE);
	waitChangeGraph();
}

